//------------------------------------------------------------------------------
#pragma hdrstop
#include "L0_Var.h"
//#include "../L0TranslatorCurr/Repository.h"
#include "StrRoutine.h"
//#include "c:\kp\ect\ect_data_api.h"
#include "RepositoryUser.h"
#include "baseType.h"
#include <sstream.h>
#include <Logger.h>
//------------------------------------------------------------------------------
#pragma package(smart_init)


const string nullPointerException("Attempt to use unexisting object");
const string unSupportedOperation("Attempt to use unsupportted operation");
const string classDoesNotExist("Class does not exist");
const string assignmentFailed("Assignment Failed.");

const int badObjID=0;
const int badInd=-1;
const int badObjectTypeID=0;
const int badLinkTypeID=0;



void terminateL0Program(){
  throw L0_Var_2_Exception("");
}


static void ShowLink2(long /*linkTypeID*/, long /*objID1*/, long /*objID2*/){
   //AnsiString o1Name=GetPropertyValue(objID1,1),
   //o2Name=GetPropertyValue(objID2,1),
   //assocName=GetTypeName(linkTypeID);
   //AnsiString msg("Link\n");
   //msg+="obj1ID : "+IntToStr(objID1)+"\n";
   //msg+="obj2ID : "+IntToStr(objID2)+"\n";
   //msg+="assocID : "+IntToStr(linkTypeID)+"\n";
   //ShowMessage(msg);
}


static void ShowLink(long /*linkTypeID*/, long /*objID1*/, long /*objID2*/){
   //ShowLink2(linkTypeID, objID1, objID2);
   //return;
   //AnsiString o1Name=GetPropertyValue(objID1,1),
   //o2Name=GetPropertyValue(objID2,1),
   //assocName=GetTypeName(linkTypeID);
   //AnsiString msg("Link\n");
   //msg+="obj1Name : "+o1Name+"\n";
   //msg+="obj2Name : "+o2Name+"\n";
   //msg+="assocName : "+assocName+"\n";
   //ShowMessage(msg);
}

static void ShowErrMsg(const string & msg ){
  #ifdef _DEBUG
    ShowMessage( msg.c_str() );
    Logger::inst().newLine();
    Logger::inst().wrtLineWithPref("!!! " + msg);
    Logger::inst().newLine();
  #endif
}//

static void ShowErrMsg( AnsiString & msg ){ ShowErrMsg( string(msg.c_str()) ); }


static string classDoesNotExist1( const string & className ){
  AnsiString s = "Class \"";
  s+=className.c_str();
  s+="\" does not exist.";
  return s.c_str();
}//

static void ShowClassDoesNotExist( const string & className ){
  AnsiString s = "Class \"";
  s+=className.c_str();
  s+="\" does not exist.";
  ShowErrMsg( s.c_str() );
}//


static void ShowAssocDoesNotExist( const string & clName , const string & assocName ){
  string s = "Association \"";
  s+=assocName.c_str();
  s+="\" starting from class \"";
  s+=clName+"\" "+"does not exist.";
  ShowErrMsg( s.c_str() );
}//

static void printIntSet( std::set< long > & s ){
  AnsiString ss;
  std::set< long >::iterator it = s.begin() , end = s.end();
  while (  it != end ){
    ss +=" ";
    ss +=IntToStr( *it );
    ++it;
  }
  ShowMessage( ss );
}//

static void printMap( std::map< long  , vector<long> > & m ){
  AnsiString s;
  std::map< long  , vector<long> >::iterator mit = m.begin() , mend =m.end();
  for( ; mit != mend ; ++mit ){
    std::vector< long > v = mit->second;
    std::vector< long >::iterator vit = v.begin() , vend =v.end();

    s+="\n<"+ IntToStr( mit->first )+"> ";

    for( ; vit != vend ; ++vit){
      s+= IntToStr ( *vit )+" ";
    }//
  }//
  ShowMessage( s );
}//

long getVectorElemIndex(const std::vector<long> * const vec , long elem){
  if ( vec ){
    for (unsigned long i=0; i < vec->size() ; i++ ){
       long l = vec->at(i);
       if ( l == elem ) return i;
    }
  }
  return badInd;
}//

long currentSessionID_ = 0;
//inline
void startSession(){currentSessionID_++;}
//inline
void endSession(){}//empty at the given point
//inline
long currentSessionID(){return currentSessionID_;}
       
//
//
//
//
//         L0_Var_2
//
//
//
//
//


bool L0_Var_2::operator==(const L0_Var_2 & rhs){
  return equals(rhs);
}//

bool L0_Var_2::operator!=(const L0_Var_2 & rhs){
  return notEquals(rhs);
}//

L0_Var_2::L0_VarKind L0_Var_2::getKind() const{
   assert( currentState );
   if (      dynamic_cast< DirectReferenceToRoot * >( currentState ) ) return DirRef;
   else if ( dynamic_cast< ReferenceByRelation * >( currentState ) )   return RefByRel;
   else if ( dynamic_cast< UnInitialized * >( currentState ) )         return UnInit;
   assert( !"UnknownKind" );
   return UnInit;
}//

string L0_Var_2::debugPrint(){
  if( isNull() ) return " null ";
  else return IntToStr( getCurrentObjID() ).c_str() ;
}

//L0_Var_2::L0_Var_2():
//  classIDInDecl( badObjectTypeID ),
//  directObjAddr( badObjectTypeID ),
//  indirectObjAddr( badObjectTypeID ),
//  uninit( badObjectTypeID )
//{
//  changeState( UnInit );
//}//

L0_Var_2::L0_Var_2(const string & className):
//  classIDInDecl( RepositoryUser::getClassIdByName( className ) ),
  classNameInDecl( className  ),
  directObjAddr  ( className , false ),
  indirectObjAddr( className  ),
  uninit         ( className  ),
  isVoidPointer( false )
{
  if( ! RepositoryUser::getClassIdByName( className ) )ShowClassDoesNotExist( className);
  changeState( UnInit );
}//


L0_Var_2::L0_Var_2():
//  classIDInDecl( RepositoryUser::getClassIdByName( className ) ),
  classNameInDecl( ""  ),
  directObjAddr  ( "" , true ),
  indirectObjAddr( ""  ),
  uninit         ( ""  ),
  isVoidPointer( true )
{
  changeState( UnInit );
}//




L0_Var_2::L0_Var_2(const L0_Var_2 & rhs):
  directObjAddr    ( rhs.directObjAddr  ),
  indirectObjAddr  ( rhs.indirectObjAddr  ),
  uninit           (  rhs.uninit  ),
  //currentState is not copied must be set in constr body
  classNameInDecl  ( rhs.classNameInDecl),
  lastInitInSession( rhs.lastInitInSession),
  isVoidPointer    ( rhs.isVoidPointer )
{
  changeState( rhs.getKind() );
  //if(this == &rhs)return;
}

L0_Var_2::~L0_Var_2()
{}//

void L0_Var_2::changeState( L0_VarKind newKind ){
  switch(newKind){
    case UnInit   : currentState = (L0_Var_2_State*)& uninit;          break;
    case DirRef   : currentState = (L0_Var_2_State*)& directObjAddr;   break;
    case RefByRel : currentState = (L0_Var_2_State*)& indirectObjAddr; break;
    default :{
     currentState=0;     assert( !"Illegal newKind value" );
    }
  }
}//

bool L0_Var_2::setFirstToRoot(const string & className){
  lastInitInSession = currentSessionID();
  changeState ( DirRef );
  return currentState->setFirstToRoot( className );
}//

bool L0_Var_2::setFirstFrom(const L0_Var_2  & startObj, const string & assocName){
  if( startObj.isNull() ){//lai varetu adekvati apstradat first X from X by r else l; aliasing
     lastInitInSession = currentSessionID();
     changeState ( RefByRel );
     setNull();
     return false;
  }
  long rhsObjID = startObj.getCurrentObjID();
  lastInitInSession = currentSessionID();
  changeState ( RefByRel );
  return currentState->setFirstFrom( rhsObjID , assocName );
}//

void L0_Var_2::setNull(){
   if( lastInitInSession < currentSessionID() ){
     changeState( UnInit );
   }else{
     currentState->setNull();
   }
   lastInitInSession = currentSessionID();
}//

bool L0_Var_2::pointsToBadObj() const{
  return currentState->pointsToBadObj();
}//

bool L0_Var_2::isNull() const{
  if( lastInitInSession < currentSessionID() )return true;
  return currentState->isNull();
}//

bool L0_Var_2::isNotNull() const{
  return ! isNull() ;
}//

bool L0_Var_2::deleteObj(){
 if ( isNull() ) return false;
 return RepositoryUser::deleteObject( getCurrentObjID() );
}//

//atgriez true ja nakamis bija atrasts
bool L0_Var_2::moveNext(){
  if( lastInitInSession < currentSessionID() ){
    changeState( UnInit );
    //return false; uninit->moveNext agriez false tapeeec return false nav vajadzigs
  }
  //if ( isNull() ) return false; citadi nevar apstradat sekojos situaciju: referencejamies uz objektu a, tad kads cits izmet objektu a ,
  return currentState->moveNext();
}//

long L0_Var_2::getCurrentObjID() const{
  if ( isNull() ) return badObjID;
  return currentState->getCurrObjID();
}//

long L0_Var_2::getCurrObjIndex()const{
  assert( currentState );
  try{
    DirectReferenceToRoot * drt =
      reinterpret_cast<DirectReferenceToRoot *>( currentState);
    return drt->currObjInd;
  }catch(...){
    return badInd;
  }
}//


long L0_Var_2::getRawObjID() const{
  return currentState->getRawObjID();
}//

bool L0_Var_2::setAttributeValue(long attributeID , const string & newValue )const{
  if ( ! isNull() ){
    if ( attributeID == 0 ){
      ShowErrMsg ( "Bad Attribute ID 0");
    }
    bool succeeded=
     RepositoryUser::setAttributeValue(getCurrentObjID(),attributeID,newValue);
    return succeeded;
  }else{
    AnsiString m = nullPointerException.c_str();
    m+="\nProgramm will now exit !";
    ShowErrMsg( m );

    terminateL0Program();

    //std::exit( EXIT_FAILURE );

    assert(false);
    return false;
  }
}//


bool L0_Var_2::setAttributeValue(const string & attrName , const string &  newValue )const{
  long objID =  getCurrentObjID();
  long objClassID = RepositoryUser::getObjectTypeId( objID );
  long attrID = RepositoryUser::getAttributeIdByName( objClassID , attrName.c_str() );
  if ( attrID == 0 ){
    ShowErrMsg("Bad Attribute ID 0.");
  }
  return setAttributeValue(attrID, newValue);
}//

bool L0_Var_2::setEnumAttributeValue(const string & attrName , const string & enumLiteralName){
  string enumLiteral_loc = enumLiteralName ;
  StrRoutine::trim( enumLiteral_loc );
  string pureEnumElemName;//no qualifier
  vector<string> v;
  StrRoutine::splitQName( enumLiteral_loc , v , pureEnumElemName );
  return setAttributeValue(attrName, pureEnumElemName);
}//

bool L0_Var_2::setBoolAttributeValue(long attributeID , bool newValue )const{
  //string valueStr = IntToStr(newValue).c_str(); checkPropertyValue neatzist ka 0 un 1 ir Bool vertibas
  string valueStr = ((newValue)?("true"):("false"));
  return setAttributeValue(attributeID, valueStr);
}//

bool L0_Var_2::setLongAttributeValue(long attributeID , long newValue )const{
  string valueStr = IntToStr(newValue).c_str();
  return setAttributeValue(attributeID, valueStr);
}//

bool L0_Var_2::setRealAttributeValue(long attributeID , double newValue )const{
  string valueStr = FloatToStr(newValue).c_str();
  return setAttributeValue(attributeID, valueStr);
}//

bool L0_Var_2::setBoolAttributeValue(const string &  attrName , bool newValue )const{
  //string valueStr = IntToStr(newValue).c_str();
  string valueStr = ((newValue)?("true"):("false"));
  return setAttributeValue(attrName, valueStr);
}//

bool L0_Var_2::setLongAttributeValue(const string &  attrName , long newValue )const{
  string valueStr = IntToStr(newValue).c_str();
  return setAttributeValue(attrName, valueStr);
}//

bool L0_Var_2::setRealAttributeValue(const string &  attrName , double newValue )const{
  string valueStr = FloatToStr(newValue).c_str();
  return setAttributeValue(attrName, valueStr);
}//

bool L0_Var_2::setStringAttributeValue(const string &  attrName , const string &  newValue )const{
  return setAttributeValue(attrName, newValue);
}//

string L0_Var_2::getAttributeValue(long attributeID) const{
  if ( ! isNull() ){
    if ( attributeID == 0 ){
      ShowErrMsg("Bad Attribute ID 0.");
    }
    string attrVal=
     RepositoryUser::getAttributeValue(getCurrentObjID(),attributeID);
    return attrVal;
  }else{
    AnsiString m = nullPointerException.c_str();
    m+="\nProgramm will now exit !";
    ShowErrMsg( m );

    terminateL0Program();

    //std::exit( EXIT_FAILURE );

    //assert(false);
    //return "";
  }
  //ShowMessage(nullPointerException.c_str());

  assert(false);
  return "";
}//


string L0_Var_2::getAttributeValue(const string & attrName) const{
  long objID =  getCurrentObjID();
  long objClassID = RepositoryUser::getObjectTypeId( objID );
  long attrID = RepositoryUser::getAttributeIdByName( objClassID , attrName.c_str() );
  if ( attrID == 0 ){
    ShowErrMsg("Bad Attribute ID 0.");
  }
  return getAttributeValue(attrID);
}//

string L0_Var_2::getEnumAttributeValue(const string & attrName ){
  string result_str = getAttributeValue( attrName );
  return attrName+"::"+result_str;
}//

bool L0_Var_2::getBoolAttributeValue(long attributeID ) const{
  string result_str = getAttributeValue(attributeID);
  //bool falseVal= result_str=="false" || result_str=="0";
  bool trueVal = result_str=="true" || result_str=="1";
  return trueVal;
}//

long L0_Var_2::getLongAttributeValue(long attributeID )const{
  string result_str = getAttributeValue(attributeID);
  long result = 0;
  try{
    result = StrToInt(result_str.c_str());
  }catch(...){
    return 0;
  }
  return result;
}//

double L0_Var_2::getRealAttributeValue(long attributeID )const{
  string result_str = getAttributeValue(attributeID);
  double result = 0.0;
  try{
	result = StrToFloat(result_str.c_str());
  }catch(...){
    return 0.0;
  }
  return result;
}//

string L0_Var_2::getStringAttributeValue(long attributeID)const{
  string result_str = getAttributeValue(attributeID);
  return result_str;
}//

long L0_Var_2::getAttrID_loc(const string & attrName)const{
  long classID = 0;
  if( isVoidPointer ){
    long objID = getCurrentObjID();
    classID = RepositoryUser::getObjectTypeId( objID );
  }else{
    classID = RepositoryUser::getClassIdByName(classNameInDecl);
  }
  return RepositoryUser::getAttributeIdByName(classID, attrName.c_str());
}

string L0_Var_2::getStringAttributeValue(const string & attrName)const{
  string result_str = getStringAttributeValue(getAttrID_loc(attrName));
  return result_str;
}//

bool L0_Var_2::getBoolAttributeValue(const string & attrName) const{
  bool res= getBoolAttributeValue(getAttrID_loc(attrName));
  return res;
}//

long L0_Var_2::getLongAttributeValue(const string & attrName)const{
  long res= getLongAttributeValue(getAttrID_loc(attrName));
  return res;
}//

double L0_Var_2::getRealAttributeValue(const string & attrName)const{
  double res = getRealAttributeValue(getAttrID_loc(attrName));
  return res;
}//

void L0_Var_2::assign( const L0_Var_2 & rhs){
  lastInitInSession = currentSessionID();
  //changed 14:26 10.10.2006. lai varetu pieskirt neinicializetam mainigam
  if( getKind() == UnInit ){
    changeState( DirRef );
    currentState->setFirstToRoot( classNameInDecl ); //inicializejam
  }
  currentState->assign( rhs );
}//

void L0_Var_2::addObj(const string & className ){
  lastInitInSession = currentSessionID();
  long classID = RepositoryUser::getClassIdByName( className );
  if( ! classID ){
    ShowClassDoesNotExist( className );
    changeState( UnInit );
    setNull();
    return;
  }
  long clIdInDecl = RepositoryUser::getClassIdByName( classNameInDecl );
  if( ! RepositoryUser::isSuperClass(clIdInDecl, classID) ){
    string msg = "Incompatible types in addObj(requested class is not subclass of declared class)\ndeclared class name : \""
                   +classNameInDecl+
                  "\"\n requested class name : \"" +className+"\".";
    throw new L0_Var_2_Exception(msg);
  }
  long createdObjID = RepositoryUser::createObject_zzz(classID);
  assert( createdObjID != badObjID );
  //if( createdObjID == badObjID ){
  //  changeState( UnInit );
  //  setNull();
  //}
  changeState( DirRef );
  currentState->addObj( createdObjID , classID );
}//


//assocName ir domats tas kas pierakstits pie klases ,
//uz kuras instancem norada this , ja skatas uz klasu diagrammu caur EBM redaktoru
void L0_Var_2::addLink( const L0_Var_2 & rhs, const string & assocName)const{
  if ( isNull() || rhs.isNull() ){
    ShowMessage("Null in AddLink.");
    return;
    //assert(false);
  }
  long
    lhs_currObjID_LOC=this->getCurrentObjID(),
    RHS_currObjID_LOC=rhs.getCurrentObjID(),
    lhsClId = RepositoryUser::getObjectTypeId( lhs_currObjID_LOC ),
    linkTypeID = RepositoryUser::getAssociationIdByName(lhsClId , assocName.c_str());
  if ( linkTypeID==0){
    ShowAssocDoesNotExist( RepositoryUser::getClassName( lhsClId ) , assocName );
    return;
    //AnsiString m ="Association does not exist.\n";
    //m+="LHS :" + GetTypeName( GetObjectTypeId (lhs_currObjID_LOC)) +".\n";
    //m+="RHS :" + GetTypeName( GetObjectTypeId (RHS_currObjID_LOC)) +".\n";
    //m+="RHS roleName: ";
    //m+= assocName.c_str();
    //ShowMessage (m);
  }
  assert(linkTypeID);
  RepositoryUser::createLink(linkTypeID,lhs_currObjID_LOC,
                                        RHS_currObjID_LOC);
}//


//assocName ir domats tas kas pierakstits pie klases ,
//uz kuras instancem norada this , ja skatas uz klasu diagrammu caur EBM redaktoru
void L0_Var_2::addLinkAfter( const string & assocName , const L0_Var_2 & rhs, const L0_Var_2 & afterPartner)const{
  if ( isNull() || rhs.isNull() || afterPartner.isNull() ){
    ShowMessage("Null in AddLink.");
    return;
    //assert(false);
  }
  long
    lhs_currObjID_LOC = this->getCurrentObjID(),
    RHS_currObjID_LOC = rhs.getCurrentObjID(),
    afterPartnerID = afterPartner.getCurrentObjID();
  long
    lhsClId = RepositoryUser::getObjectTypeId( lhs_currObjID_LOC ),
    linkTypeID = RepositoryUser::getAssociationIdByName(lhsClId , assocName.c_str());
  if ( linkTypeID==0){
    ShowAssocDoesNotExist( RepositoryUser::getClassName( lhsClId ) , assocName );
    return;
    //AnsiString m ="Association does not exist.\n";
    //m+="LHS :" + GetTypeName( GetObjectTypeId (lhs_currObjID_LOC)) +".\n";
    //m+="RHS :" + GetTypeName( GetObjectTypeId (RHS_currObjID_LOC)) +".\n";
    //m+="RHS roleName: ";
    //m+= assocName.c_str();
    //ShowMessage (m);
  }
  assert(linkTypeID);
  RepositoryUser::createLinkAfter(linkTypeID,lhs_currObjID_LOC,
                                        RHS_currObjID_LOC, afterPartnerID);
}//


void L0_Var_2::deleteLink(const L0_Var_2 & rhs, const string &  assocName)const{
  if ( isNull() || rhs.isNull() ){
    ShowMessage("Null in Delete Link. No deletion occured.");
    return;
  }
  long
    lhs_currObjID_LOC=this->getCurrentObjID(),
    RHS_currObjID_LOC=rhs.getCurrentObjID(),
    lhsClId = RepositoryUser::getObjectTypeId(lhs_currObjID_LOC),
    linkTypeID = RepositoryUser::getAssociationIdByName(lhsClId,assocName.c_str());
  if ( linkTypeID==0){
    ShowAssocDoesNotExist( RepositoryUser::getClassName( lhsClId ), assocName );
    //AnsiString m ="Association does not exist.\n";
    //m+="LHS :" + GetTypeName( GetObjectTypeId (lhs_currObjID_LOC)) +".\n";
    //m+="RHS :" + GetTypeName( GetObjectTypeId (RHS_currObjID_LOC)) +".\n";
    //m+="RHS roleName: ";
    //m+= assocName.c_str();
    //ShowMessage (m);
    return;
  }

  assert(linkTypeID);
  RepositoryUser::deleteLink(linkTypeID,lhs_currObjID_LOC,
                                        RHS_currObjID_LOC);
}//

bool L0_Var_2::isTypeOf(const string & className)const{
  if ( isNull() ){
    //ShowMessage ( "Null in isTypeOf." );
    AnsiString m = "Null in isTypeOf.";
    m+="\nProgramm will now exit !";
    ShowMessage( m );

    terminateL0Program();

    //std::exit( EXIT_FAILURE );

    //assert(false);
    //return "";

    //assert( ! "Null in isTypeOf." );
  }

  long classIdByName = RepositoryUser::getClassIdByName(className.c_str());
  if ( classIdByName==0 ) return false;

  long objCurrType = RepositoryUser::getObjectTypeId( getCurrentObjID());

  bool match = objCurrType == classIdByName ;
  return match;
}//

bool L0_Var_2::equals( const L0_Var_2 & rhs )const{
   bool bothNull = isNull() && rhs.isNull();
   if ( bothNull ) return true;
   // viens ir null , bet otrs nav null
   if ( isNull() || rhs.isNull() ) return false;

   bool pointedObjEquals = getCurrentObjID() == rhs.getCurrentObjID() ;
   return pointedObjEquals;
}//

bool L0_Var_2::notEquals( const L0_Var_2 & rhs )const{
   return ! equals ( rhs );
}//

bool L0_Var_2::hasLink( const L0_Var_2 & rhs , const string &   assocName)const{
  if ( isNull() || rhs.isNull() ) return false;
  long currClassID = RepositoryUser::getObjectTypeId( getCurrentObjID() );
  long linkID = RepositoryUser::getAssociationIdByName( currClassID , assocName.c_str() );
  if( linkID == 0 ){
    ShowAssocDoesNotExist( RepositoryUser::getClassName( currClassID ) , assocName );
    return false;
  }
  bool existsLink = Links::instance().existsLink(linkID,getCurrentObjID(),
                                                 rhs.getCurrentObjID());
  return existsLink;
}//

bool L0_Var_2::hasNoLink( const  L0_Var_2 & rhs ,  const string &   assocName)const{
  return ! hasLink ( rhs , assocName );
}//


//
//
//
//
//         L0_Var_2::ReferenceByRelation
//
//
//
//
//




L0_Var_2::ReferenceByRelation::ReferenceByRelation(const string & classIdInDecl_prm):
L0_Var_2_State( classIdInDecl_prm )
{
  setNull();
}//

L0_Var_2::ReferenceByRelation::ReferenceByRelation(const ReferenceByRelation & rhs ):
 L0_Var_2_State  ( rhs.classNameInDecl ),
 currObjInd      ( rhs.currObjInd ),
 currPartnersList( rhs.currPartnersList ),
 startObjID      ( rhs.startObjID ),
 assocID         ( rhs.assocID ),
 outOfBounds     ( rhs.outOfBounds )
{}//



//long L0_Var_2::ReferenceByRelation::getCurrObjID(){
//  assert( ! isNull() );
//  long currObjID = (*currPartnersList)[currObjInd];
//  return currObjID;
//}//

long L0_Var_2::ReferenceByRelation::getCurrObjID(){
  assert( ! isNull() );
  return getRawObjID();
}//

long L0_Var_2::ReferenceByRelation::getRawObjID() const{
  bool canGetID = currPartnersList &&
                  currObjInd >= 0  &&
                  currObjInd < currPartnersList->ids->size();
  if( canGetID ){
    //long currObjID = (*currPartnersList)[currObjInd];
    long currObjID = currPartnersList->ids->at(currObjInd);
    return currObjID;
  }
  return badObjID;
}//

bool L0_Var_2::ReferenceByRelation::setFirstFrom(const L0_Var_2 & startObj , const string & assocName){
  if( startObj.isNull() ){
    setNull();
    return false;
  }

  startObjID = startObj.getCurrentObjID();
  long startObjClassID = RepositoryUser::getObjectTypeId( startObjID );
  assocID = RepositoryUser::getAssociationIdByName( startObjClassID , assocName.c_str() );
  bool assocExists = assocID > 0;
  if ( ! assocExists ){
     ShowAssocDoesNotExist( RepositoryUser::getClassName( startObjClassID ) , assocName );
     setNull();
     return false;
  }
  //populate partners
  //bool existsRecord =
  //  LinkedPartnersIDListS::instance().existsRecord(assocID,startObjID);
  //
  //currPartnersList=0;
  //if ( ! existsRecord ){
  //  bool put=
  //    LinkedPartnersIDListS::instance().putRecord(assocID,startObjID);
  //    assert(put);
  //}
  currPartnersList =
    LinkedPartnersIDListS::instance().getPartners_2(assocID,startObjID);
  assert(currPartnersList);

  currObjInd=badInd;
  outOfBounds = false;

  return moveNext();
}//


bool L0_Var_2::ReferenceByRelation::setFirstFrom(long startObjID_prm , const string & assocName){
  this->startObjID = startObjID_prm;
  long startObjClassID = RepositoryUser::getObjectTypeId( this->startObjID );
  assocID = RepositoryUser::getAssociationIdByName( startObjClassID , assocName.c_str() );
  bool assocExists = assocID > 0;
  if ( ! assocExists ){
     ShowAssocDoesNotExist( RepositoryUser::getClassName( startObjClassID ) , assocName );
     setNull();
     return false;
  }
  //populate partners
  //bool existsRecord =
  //  LinkedPartnersIDListS::instance().existsRecord(assocID,startObjID);
  //
  //currPartnersList=0;
  //if ( ! existsRecord ){
  //  bool put=
  //    LinkedPartnersIDListS::instance().putRecord(assocID,startObjID);
  //    assert(put);
  //}
  currPartnersList =
    LinkedPartnersIDListS::instance().getPartners_2(assocID,startObjID);
  assert(currPartnersList);

  currObjInd=badInd;
  outOfBounds = false;

  return moveNext();
}//


void L0_Var_2::ReferenceByRelation::setNull(){
  currObjInd       = badInd;
  currPartnersList = 0;
  startObjID       = badObjID;
  assocID          = badLinkTypeID;
  outOfBounds      = false;
}//

bool L0_Var_2::ReferenceByRelation::isNull(){
  if( outOfBounds ) return true;
  bool preSatisfied = currPartnersList &&
             currObjInd != badInd &&
             currObjInd < currPartnersList->ids->size() &&
             RepositoryUser::objectExists(startObjID);
  if ( !  preSatisfied ) return true; // ja, ir null
  long currObjID_loc = currPartnersList->ids->at(currObjInd);
  bool referLinkExists =
    ! currPartnersList->skipId->at(currObjInd) && 
    RepositoryUser::objectExists( currObjID_loc ) &&
    Links::instance().existsLink(assocID , startObjID , currObjID_loc);
  return ! referLinkExists;
}//

long L0_Var_2::ReferenceByRelation::getFirstLegalObjIndex(//long startObjID ,
                                                          //const std::vector<long> * partners ,
                                                          long startIndex){
  bool pre = currPartnersList &&
             startIndex < currPartnersList->ids->size() &&
             RepositoryUser::objectExists(startObjID);
  if (! pre ) return badInd;
  long elemCount =  currPartnersList->ids->size();
  for(long i=startIndex ; i < elemCount ; i++ ){
    //long rhsObjID = (*currPartnersList)[i];
    long rhsObjID = currPartnersList->ids->at(i);
    bool legal = ! currPartnersList->skipId->at(i) &&
                 Links::instance().existsLink(assocID,startObjID, rhsObjID );
    //bool legal1 = RepositoryUser::linkExists(assocID,startObjID, rhsObjID );//for debugging
    //assert( legal1 == legal );//for debugging
    if (legal) return i;
  }
  return badInd;
}//


bool L0_Var_2::ReferenceByRelation::moveNext(){
  long objInd_LOC=badInd;
  //objInd_LOC=getFirstLegalObjIndex(startObjID,currPartnersList,currObjInd+1);
  objInd_LOC=getFirstLegalObjIndex( currObjInd+1 );

  if( objInd_LOC != badInd){ // nakamais ir atrasts
    currObjInd=objInd_LOC;
    outOfBounds=false;
    return true;
  }else{
    outOfBounds=true;
    return false;
  }
}//

void L0_Var_2::ReferenceByRelation::assign(const L0_Var_2 & rhs){
  if( rhs.isNull() ){
    //assignNullRhs( rhs ); 
    setNull();
    assert( isNull() );
    return;
  }
  L0_VarKind rhsKind = rhs.getKind();
  switch(rhsKind){
    case DirRef:   //apzinati izlaists
    case RefByRel:{
      long desiredID  = rhs.getCurrentObjID();
      long objIndTemp = currPartnersList->getVectorElemIndex( desiredID );
      bool found      = objIndTemp != badInd;
      if( found ){
        currObjInd=objIndTemp;
        outOfBounds=false;
      }else{
        ShowErrMsg( assignmentFailed );
        setNull();
        return;
      }
      assert( getCurrObjID() == rhs.getCurrentObjID() );
    }break;
    case UnInit:{
      setNull();
    }break;
    default: assert(!"Illegal var kind."); break;
  }//switch rhs kind
}//


//
// !!! loti aizdomiga funkcija Nav istas skaidribas vai sada veida pieskirsana
//     ir nepieciesama
//     Vai seit nevaretu iztikt bez sada veida pieskirsanas tikai ar setNull()
//
void L0_Var_2::ReferenceByRelation::assignNullRhs( const L0_Var_2 & rhs ){
  assert( rhs.isNull() );
  //  if ( rhs.pointsToBadObj() ){
  //    long desiredID  = rhs.getRawObjID();
  //    long objIndTemp = getVectorElemIndex(currPartnersList,desiredID);  ;
  //    bool found      = objIndTemp != badInd ;
  //    if ( found ){
  //      currObjInd  = objIndTemp;
  //      outOfBounds = false;
  //      return;
  //    }
  //  }
  //  ShowErrMsg(assignmentFailed);
  //  setNull();
  if( rhs.pointsToBadObj() ){
    if( rhs.getKind() == RefByRel ){
      bool canSynchronize = this->startObjID == rhs.indirectObjAddr.startObjID &&
                            this->assocID == rhs.indirectObjAddr.assocID;
      if( canSynchronize ){
         currObjInd  = rhs.indirectObjAddr.currObjInd;
         outOfBounds = rhs.indirectObjAddr.outOfBounds;
         return;
      }
    }
  }
  setNull();
}//

//f-jas semantika ir sekojosa Parbauda vai mainigais rada uz ID, kas neatbilst
//prieksnosacijumiem(iznicinats objekts, objekts bez atbilstosas saites)
inline
bool L0_Var_2::ReferenceByRelation::pointsToBadObj(){
  if ( outOfBounds ) return false;
  if ( currObjInd==badInd || startObjID==badObjID || assocID == 0 ) return false;
  return true;
}//

//
//
//
//
//         L0_Var_2::DirectReferenceToRoot
//
//
//
//
//

L0_Var_2::DirectReferenceToRoot::DirectReferenceToRoot(const string & classIdInDecl_prm, bool isVoid_prm):
  L0_Var_2_State( classIdInDecl_prm )
{
  //subClassesIDs = 0;
  //currSubClassIDInd = badInd;
  //currObjInd = badInd;
  currObjInd = 0;
  currSubClassIDInd = 0;
  outOfBounds = false;
  subClassesIDs = 0;
  isVoidPointer = isVoid_prm;
}//

L0_Var_2::DirectReferenceToRoot::DirectReferenceToRoot(const DirectReferenceToRoot & rhs):
  L0_Var_2_State(rhs.classNameInDecl)
{
  currObjInd        = rhs.currObjInd;
  currSubClassIDInd = rhs.currSubClassIDInd;
  outOfBounds       = rhs.outOfBounds;
  //subClassesIDs     = rhs.subClassesIDs; tiek apstradats zemak
  isVoidPointer     = rhs.isVoidPointer;
  
  //assert( rhs.subClassesIDs );
  if( rhs.subClassesIDs ){
    subClassesIDs = new vector<long>( * rhs.subClassesIDs );
  }else{
    subClassesIDs=0;
  }
  //assert( subClassesIDs );
}//


L0_Var_2::DirectReferenceToRoot::~DirectReferenceToRoot(){
  delete subClassesIDs;  subClassesIDs=0;
}//

long L0_Var_2::DirectReferenceToRoot::getCurrObjID(){
  assert( ! isNull() );
  return getRawObjID();
}//

long L0_Var_2::DirectReferenceToRoot::getRawObjID() const{
  bool canGetID = subClassesIDs &&
                  currSubClassIDInd >= 0  &&
                  currSubClassIDInd < subClassesIDs->size() &&
                  currObjInd >=0;
  if( canGetID ){
    long currSubClassID_loc = subClassesIDs->at(currSubClassIDInd);
    long currObjID = L0_ObjectIDListS::instance().getObjID( currSubClassID_loc , currObjInd );
    return currObjID;
  }
  return badObjID;
}//

bool L0_Var_2::DirectReferenceToRoot::setFirstToRoot(const string & className){
  /*DONE : and what if className is not a subclass of classIDInDecl*/
  long clID = RepositoryUser::getClassIdByName( className );
  if( ! clID ){
    ShowClassDoesNotExist( className );
    setNull();
    return false;
  }
  setNull();
  if( ! isVoidPointer ){
    long clIdInDecl = RepositoryUser::getClassIdByName( classNameInDecl );
    if ( ! RepositoryUser::isSuperClass( clIdInDecl , clID ) ){
      string msg = "Incompatible types in setFirstToRoot\ndeclared type : \"" +classNameInDecl+
                   "\"\nclass requested in setFirstToRoot : \"" +className+"\".";
      throw new L0_Var_2_Exception(msg);
    }
  }

  subClassesIDs = RepositoryUser::getAllSubClassesID( className );

  assert( subClassesIDs );
  return moveNext();
}//

void L0_Var_2::DirectReferenceToRoot::setNull(){
  delete subClassesIDs;  subClassesIDs=0;
  currSubClassIDInd = badInd;
  currObjInd = badInd;
  outOfBounds = false;
}//

bool L0_Var_2::DirectReferenceToRoot::pointsToBadObj(){
  if ( outOfBounds ) return false;
  if ( currObjInd==badInd || currSubClassIDInd==badInd ) return false;
  return true;
}//

bool L0_Var_2::DirectReferenceToRoot::isNull(){
   if ( outOfBounds ) return true;
   bool indexesOk =
        subClassesIDs &&
        currSubClassIDInd < subClassesIDs->size() &&
        currSubClassIDInd != badInd &&
        currObjInd != badInd;
   if( ! indexesOk ) return true;
   long referencedObjID = L0_ObjectIDListS::instance().getObjID(subClassesIDs->at(currSubClassIDInd), currObjInd );
   bool referencedObjExists = RepositoryUser::objectExists(referencedObjID);
   return ! referencedObjExists;
}//


//void L0_Var_2::DirectReferenceToRoot::initSubClassesID( const string & className){
//    long clID = RepositoryUser::getClassIdByName( className );
//    if( ! clID ){
//      ShowClassDoesNotExist( className );
//      setNull();
//      return false;
//    }
//    long clIdInDecl = RepositoryUser::getClassIdByName( classNameInDecl );
//    if ( ! RepositoryUser::isSuperClass( clIdInDecl , clID ) ){
//       string msg = "Incompatible types in setFirstToRoot\ndeclared type : \"" +classNameInDecl+
//                  "\"\nclass requested in setFirstToRoot : \"" +className+"\".";
//       throw new L0_Var_2_Exception(msg);
//    }
//    setNull();
//    subClassesIDs = RepositoryUser::getAllSubClassesID( className );
//    assert( subClassesIDs );
//}//


bool L0_Var_2::DirectReferenceToRoot::moveNext(){
  assert( subClassesIDs );

  if( ! subClassesIDs ){
    return false;
  }

  long subClassInd_LOC=badInd , objInd_LOC=badInd;
  bool succeed_LOC=false;

  if ( currSubClassIDInd == badInd && currObjInd == badInd ){//pirmaisMoveNextIzsaukums
    succeed_LOC = getFirstLegalObjIndex( subClassesIDs ,
                                         0 , 0,
                                         subClassInd_LOC, objInd_LOC );
  }else{
    succeed_LOC=  getFirstLegalObjIndex( subClassesIDs ,
                                         currSubClassIDInd , currObjInd+1,
                                         subClassInd_LOC, objInd_LOC );
  }

  if (succeed_LOC){
    currSubClassIDInd=subClassInd_LOC;
    currObjInd=objInd_LOC;
    outOfBounds=false;
  }else{
    outOfBounds=true;
  }
  return succeed_LOC;
}//

//
// !!! loti aizdomiga funkcija Nav istas skaidribas vai sada veida ppieskirsana
//     ir nepieciesama
//     Vai seit nevaretu iztikt bez sada veida pieskirsanas tikai ar setNull()
//
void L0_Var_2::DirectReferenceToRoot::assignNullRhs(const L0_Var_2 & rhs){
  //assert( rhs.isNull() );
  //if ( rhs.pointsToBadObj() ){
  //  long desiredID = rhs.getRawObjID();
  //  long newSubClInd , newObjInd ,
  //       desiredIdInd  = findDesiredIDPosition( desiredID , newSubClInd , newObjInd );
  //  bool found = desiredIdInd != badInd ;
  //  if( found ){
  //      currObjInd = newObjInd;
  //      currSubClassIDInd = newSubClInd;
  //      outOfBounds = false;
  //      return;
  //  }
  //}
  //ShowErrMsg(assignmentFailed);
  //setNull();

  if( rhs.pointsToBadObj() ){
    if( rhs.getKind() == DirRef ){// ja kind sakrit tad varam sinhronizet jo L0 kompilators parbauda tipu atbilstibu
      //long rhsCurrSubClassID = rhs.directObjAddr.subClassesIDs->at(rhs.directObjAddr.currObjInd); probalby a bug must be currSubClassIDInd
      long rhsCurrSubClassID = rhs.directObjAddr.subClassesIDs->at(rhs.directObjAddr.currSubClassIDInd);
      long currSubClassInd_loc = getSubClassIndex( rhsCurrSubClassID );
      if( currSubClassInd_loc == badInd ){
        setNull();
        return;
      }
      currObjInd = rhs.directObjAddr.currObjInd;
      outOfBounds = rhs.directObjAddr.outOfBounds;
      return;
    }
  }
  setNull();
}//

void L0_Var_2::DirectReferenceToRoot::assign(const L0_Var_2 & rhs){
  long clID = RepositoryUser::getClassIdByName( classNameInDecl );
  if( ! clID ){
       ShowClassDoesNotExist( classNameInDecl );
       setNull();
       return;
  }

  if( rhs.isNull() ){
     assignNullRhs( rhs );
     assert( this->isNull() );
     return;
  }

  L0_VarKind rhsKind = rhs.getKind();
  switch(rhsKind){
    case DirRef:{

       if( ! subClassesIDs ){ //uz si L0 pointera nebija izsaukts first
          if( isVoidPointer ){
            subClassesIDs = RepositoryUser::getAllClassesIDs();//skatamies uz visam klasem
          }else{
            subClassesIDs = RepositoryUser::getAllSubClassesID( classNameInDecl );//skatamies uz sis klases apaksklasem
          }
       }

       long rhsCurrObjClassID = RepositoryUser::getObjectTypeId( rhs.getCurrentObjID() );
       long currSubClassIDIndTemp = getSubClassIndex( rhsCurrObjClassID );

       if( currSubClassIDIndTemp == badInd ){
         //assert(!"Incompatible types in assignment.");
         ShowErrMsg(assignmentFailed);
         setNull();
         return;
       }

       currSubClassIDInd = currSubClassIDIndTemp;
       currObjInd = rhs.getCurrObjIndex();
       outOfBounds = false;

       assert( getCurrObjID() == rhs.getCurrentObjID() );
    }break;
    case RefByRel:{
      //meklesanu varetu optimizet sakuma sanemot rhs.GetCurrentObjID,
      //tad nosakot rhs.currObjID tipu un lietojot getObjTypeID , getSubClassIndex 
      long desiredID = rhs.getCurrentObjID();
      long newSubClInd=badInd, newObjInd=badInd;
      bool found = findDesiredIDPosition(desiredID,newSubClInd,newObjInd);
      if ( found ){
        currObjInd=newObjInd;
        currSubClassIDInd = newSubClInd;
        outOfBounds = false;
      }else{
        //assert(!"Incompatible types in assignment.");
        ShowErrMsg(assignmentFailed);
        setNull();
        return;
      }
      assert( getCurrObjID() == rhs.getCurrentObjID() );
    }break;
    case UnInit:{
      setNull();
    }break;
    default:{ assert(!"Illegal VarKind"); }break;
  }//switch rhsKind
}//

//pozicionejam this ta lai vins noraaditu uz jaunizveidoto objektu
void L0_Var_2::DirectReferenceToRoot::addObj( long newObjID , long newObjClassID){
  /*DONE : and what if addObj is called before setFirstToRoot was called*/
  setNull();

  subClassesIDs = RepositoryUser::getAllSubClassesID( classNameInDecl );

  assert( subClassesIDs );
  long subClassPos = getSubClassIndex( newObjClassID );
  assert( subClassPos != badInd );
  long referencedClassObjCount=
    L0_ObjectIDListS::instance().elementCount( newObjClassID );
  assert(referencedClassObjCount>0); //vismaz viens tikko izveidots

  currSubClassIDInd = subClassPos;
  currObjInd        = referencedClassObjCount-1;
  assert( newObjID == L0_ObjectIDListS::instance().getObjID(newObjClassID,currObjInd) );
  outOfBounds=false;
}//


bool L0_Var_2::DirectReferenceToRoot::getFirstLegalObjIndex(
                             const vector<long> * const subClassesIDs,
                             long classIndexStartPos, long objStartPos,
                             long & resultingClassIndex , long & resultingObjIndex
                             )
{
   bool pre = subClassesIDs && classIndexStartPos < subClassesIDs->size();// objStaartPos ???;
   assert(pre);
   bool firstNestedLoopIter=true;
   long subClassCount = subClassesIDs->size();
   for( long classIDInd=classIndexStartPos ; classIDInd < subClassCount ; classIDInd++ ){
       long objPos; // cikla skaititajs
       if ( firstNestedLoopIter ){
         objPos=objStartPos;
         firstNestedLoopIter=false;
       }else{
         objPos=0;
       }
       long currSubClassID = subClassesIDs->at(classIDInd) ;
       const vector<long> * objects = L0_ObjectIDListS::instance().getObjects(currSubClassID);

       long objCount =  ( objects ? objects->size() : -1 );
       if(!objects) goto error;

       for( ; objPos < objCount ; objPos++)
       {
          long referObjID = objects->at(objPos);
          bool objExists = RepositoryUser::objectExists( referObjID );
          if (objExists){
             resultingClassIndex=classIDInd;
             resultingObjIndex=objPos;
             return true;
          }
       }//

       //for( ;
       //    objPos < L0_ObjectIDListS::instance().elementCount((*subClassesIDs)[classIDInd]);
       //    objPos++)
       //{
       //   long referObjID =
       //      L0_ObjectIDListS::instance().getObjID( (*subClassesIDs)[classIDInd],
       //                                              objPos );
       //   bool objExists = RepositoryUser::objectExists( referObjID );
       //   if (objExists){
       //     resultingClassIndex=classIDInd;
       //      resultingObjIndex=objPos;
       //      return true;
       //   }
       //}//

   }//
error:
  resultingClassIndex=badInd;
  resultingObjIndex=badInd;
  return false;
}//

long L0_Var_2::DirectReferenceToRoot::getSubClassIndex(long subClassID)const{
  return getVectorElemIndex( subClassesIDs , subClassID );
  //if( subClassesIDs ){
  //   long size = subClassesIDs->size();
  //   for( long i=0 ; i < size ; i++ ){
  //     if ( (*subClassesIDs)[i] == subClassID ) return i;
  //   }
  // }
  // return badInd;
}//

bool L0_Var_2::DirectReferenceToRoot::findDesiredIDPosition(
                                 long desiredID_prm, long & currSubClassIDInd_prm ,
                                 long & currObjInd_prm)const
{
  long objTypeId = RepositoryUser::getObjectTypeId( desiredID_prm );
  long subClassInd = getSubClassIndex( objTypeId );

  if( subClassInd == badInd ) goto not_found;

  for(long objPos=0 ;
           objPos < L0_ObjectIDListS::instance().elementCount( objTypeId );
           objPos++)
  {
    long objID=
         L0_ObjectIDListS::instance().getObjID( objTypeId , objPos );
    if( objID == desiredID_prm ){
      currSubClassIDInd_prm=subClassInd;
      currObjInd_prm=objPos;
      return true;
    }
  }

not_found:
  return false;
}//















//
//
//
//
//       class L0_ObjectIDListS
//
//
//
//


L0_ObjectIDListS::L0_ObjectIDListS()
{
   return;


   //vector<long> classIDList;
   //RepositoryUser::getAllClasses( classIDList );
   //
   //for( unsigned int i=0 ; i < classIDList.size() ; i++ ){
   //  bool hasSubType = RepositoryUser::hasSubClasses( classIDList[i] );
   //  if ( hasSubType ){
   //      initClassWithSubClasses( classIDList[i] );
   //  }else{
   //      initClassWithoutSubClasses( classIDList[i] );
   //  }
   //}//for
}//



L0_ObjectIDListS::~L0_ObjectIDListS()
{
  std::map< long , std::pair< vector<long> * , long > >::iterator
    it = classes.begin(),
    end = classes.end();
  for( ; it != end ; ++it){
     delete  it->second.first; it->second.first=0;
  }//for
  //ShowMessage("L0_ObjectIDListS::~L0_ObjectIDListS destructor");
}

//pre : ja klasei A ir apaksklases B,C,D ,... , tad tiek pienemts
// ka klases A objekti klases A objektu saraksta bus pirmie
void L0_ObjectIDListS::initClassWithSubClasses( long classID )
{
  int totalObjCount = RepositoryUser::getObjectNum(classID);

  vector<long> * id_vec = new vector<long>;

  for (int i=0 ; i < totalObjCount ; ++i ){
     long currObjId = RepositoryUser::getObjectIdByIndex( classID, i);
     assert(currObjId);
     if ( RepositoryUser::getObjectTypeId( currObjId ) == classID ){
       //(*id_vec)[i].=currObjId;   !!! jalieto reserve
       id_vec->push_back(currObjId);
     }else break;
  }
  std::pair< long , std::pair<vector<long> *, long> > p(classID , make_pair(id_vec,123) );
  //bool inserted = classes1.insert(p).second;
//  assert( inserted );
}//

void L0_ObjectIDListS::initClassWithoutSubClasses(long classID )
{
  int objCount = RepositoryUser::getObjectNum(classID);

  vector<long> * id_vec = new vector<long>( objCount ) ;

  for (int i=0 ; i < objCount ; ++i ){
    long objID=RepositoryUser::getObjectIdByIndex( classID, i);
    assert(objID);
    (*id_vec)[i]=objID;
  }
//  std::pair< long , vector<long> * > p(classID , id_vec);
//  bool inserted = classes1.insert(p).second;
//  assert( inserted );

}//

void L0_ObjectIDListS::retrieveObjects(long classID , vector<long> * vec )
{
  int totalObjCount = RepositoryUser::getObjectNum(classID);
  for (int i=0 ; i < totalObjCount ; i++ ){
     long currObjId = RepositoryUser::getObjectIdByIndex( classID, i);
     assert(currObjId);
     if ( RepositoryUser::getObjectTypeId( currObjId ) == classID ){
       //(*id_vec)[i].=currObjId;   !!! jalieto reserve
       assert( vec );
       vec->push_back(currObjId);
     }else break;
  }
}//


L0_ObjectIDListS & L0_ObjectIDListS::instance()
{  //ShowMessage("L0_ObjectIDListS::Instance");
   static L0_ObjectIDListS  s;
   return s;
}//

//inline
long L0_ObjectIDListS::elementCount (long classID)// const
{
  vector<long> * classObjects = getObjectsRaw( classID );
  if(!classObjects) return -1;
  return classObjects->size();

  //assert(!"Not  finished");
  //std::map< long , std::pair<vector<long> *, long> >::const_iterator it = classes.find( classID );
  //if( it == classes.end() ){
  //  assert(false);
  //  return -1;
  //}
  //assert( it->second.first );
  //return it->second.first->size();
}//

//inline
long L0_ObjectIDListS::getObjID( long classID , long objInd )
{
  vector<long> * classObjects = getObjectsRaw( classID );
  if(!classObjects) return -1;
  assert( objInd < classObjects->size() );
  long ret=classObjects->at(objInd);
  return ret;

  //assert(!"Not  finished");
  //map< long , std::pair< vector<long> *,long> >::const_iterator it = classes.find( classID );
  //if( it == classes.end() ){
  //  assert(false);
  //  return -1;
  //}
  //assert( it->second.first && objInd < (it->second.first)->size() );
  //long ret=it->second.first->operator[](objInd);
  //return ret;
}//

const vector<long> * L0_ObjectIDListS::getObjects(long classID){
  return getObjectsRaw( classID );
}//

vector<long> * L0_ObjectIDListS::getObjectsRaw(long classID){

  if( ! RepositoryUser::classExists( classID ) )return 0;

  map< long , std::pair< vector<long> *,long> >::iterator it = classes.find( classID );
  if( it == classes.end() ){
    //ja neeksiste ieladejam to
    vector<long> * id_vec = new vector<long>();
    retrieveObjects( classID , id_vec );
    bool inserted = classes.insert( make_pair( classID , make_pair(  id_vec , currentSessionID() ) )
                                   ).second;
    assert( inserted );
    return id_vec;
  }else{
    if( it->second.second < currentSessionID() ){
      it->second.first->clear();
      retrieveObjects( classID , it->second.first );
      //atzimejam kad ieladejam
      it->second.second = currentSessionID();
    }
    return it->second.first;
  }
}//

//inline                 
bool L0_ObjectIDListS::isCorrectIndex( long classID , long objInd)
{
  map< long , std::pair< vector<long> * , long> >::iterator it = classes.find( classID );
  if( it == classes.end() ) return false;
  if( ! it->second.first ) return false;
  if( objInd >= it->second.first->size() || objInd < 0 ) return false;
  return true;
}//

//inline
//long L0_ObjectIDListS::addObjID(long classID , long newObjID) //atgriez jauna objekta indeksu
//{
//  assert( classID == RepositoryUser::getObjectTypeId( newObjID ));
//  map< long , std::pair< vector<long> * , long > >::iterator it = classes.find( classID );
//  if( it == classes.end() ){//liekam jaunu klasi
//    vector<long> * id_vec = new vector<long>();
//    id_vec->push_back( newObjID );
//    bool inserted =classes.insert( make_pair( classID , make_pair(  id_vec , currentSessionID() ) )
//                                   ).second;
//    assert( inserted );
//    return 0;
//  }
//
//  assert( it->second.first );
//
//  //skatamies vai objekti ieladeti sis sesijas laika
//  if( it->second.second < currentSessionID() ){
//    //parladejam
//    it->second.first->clear();
//    //un pievienojam
//    retrieveObjects( classID , it->second.first );
//    //atzimejam kad ieladejam
//    it->second.second = currentSessionID();
//  }else{
//    //ja sis sesijas laika tad , tad vienkrasi pievienojam
//    it->second.first->push_back( newObjID );
//  }
//  return it->second.first->size()-1;
//}//



long L0_ObjectIDListS::createObject(long classID){
  vector<long> * objects = getObjectsRaw( classID );
  assert( objects );
  long newObjID = RepositoryUser::createObjectRaw( classID );
  if (!newObjID) return badObjID;
  objects->push_back( newObjID );
  return newObjID;
}//

//void L0_ObjectIDListS::addClassID( long classID ){
//  map< long , vector<long> * >::iterator it = classes.find( classID );
//  if( it != classes.end() ){
//    assert( !"Class with specified ID already exists" );
//    return;
//  }else{//liekam jaunu klasi
//    vector<long> * id_vec = new vector<long>();
//    bool inserted =classes.insert( make_pair( classID , id_vec ) ).second;
//    assert( inserted );
//  }
//}//


//
//
//
//
//         class LinkedPartnersIDListS
//
//
//
//




LinkedPartnersIDListS::LinkedPartnersIDListS()
{
  //ShowMessage("LinkedPartnersIDListS::LinkedPartnersIDListS()");
  //initPartnersIdListS();
}//


void LinkedPartnersIDListS::initPartnersIdListS()
{
  vector<long> allLinkTypes; //visu asociaciju ID
  RepositoryUser::getAllLinkTypes(& allLinkTypes);

  for (unsigned long i=0 ; i < allLinkTypes.size() ; i++){
    addAssocID( allLinkTypes[i] );
    //std::map<long , vector<long> *  > *
    //         startObjID_partners = new std::map< long , vector<long> * >();
    //
    //std::pair<long ,std::map<long , vector<long> *  > * >
    //                         currPair( allLinkTypes[i], startObjID_partners);
    //bool inserted= linkedPartners.insert( currPair ).second ;
    //assert(inserted);
  }

}//

LinkedPartnersIDListS::~LinkedPartnersIDListS()
{
 //map<long , map<long , vector<long>* >* >::iterator
  map<long , map<long , std::pair< MyLinkedPartnersList *  , long > > * >::iterator
   iter = linkedPartners2.begin(),
   end  = linkedPartners2.end();

  for( ; iter != end ; ++iter ){
      //map<long , vector<long>* >::iterator
      map<long , std::pair< MyLinkedPartnersList * , long > >::iterator
        iter2 = iter->second->begin(),
        iter2_end = iter->second->end();

        for(; iter2 != iter2_end; ++iter2){
          std::pair< MyLinkedPartnersList * , long > p = iter2->second;
          delete p.first; p.first=0;//delete vector
          iter2->second.first=0;
        }//
      delete iter->second; iter->second=0;//delete map
  }//for outer

 //ShowMessage("LinkedPartnersIDListS::~LinkedPartnersIDListS() destructor");
}//

LinkedPartnersIDListS & LinkedPartnersIDListS::instance()
{
  //ShowMessage("LinkedPartnersIDListS::::initInstance");
   static LinkedPartnersIDListS inst;
   return inst;
}//


//vector<long> * LinkedPartnersIDListS::getPartners(long linkTypeID, long startObjectID)
//{
//  map<long , map< long , vector<long>* >* >::iterator
//      iter=linkedPartners.find(linkTypeID),
//      end=linkedPartners.end();
//  if ( iter != end ){ //atrasts elements ar tadu linkTypeId
//    map< long , vector<long>* >::iterator
//      iter2= iter->second->find(startObjectID),
//      end2=iter->second->end();
//    if (iter2 != end2){       //atrast elements ar tadu startObjectId
//      return iter2->second;
//    }
//  }else{//skatamies vai repo eksiste tada assoc
//    if(! RepositoryUser::assocExists(linkTypeID) ){
//      return 0;
//    }
//
//  }
//  return 0;
//}//

//obj - eksiste
//no obj klases ir assoc ar linkTypeId
/*
vector<long> * LinkedPartnersIDListS::getPartners1(long linkTypeID, long startObjectID){
  bool pre = RepositoryUser::objectExists( startObjectID ) &&
             RepositoryUser::assocExists( linkTypeID )     &&
             RepositoryUser::assocStartsFrom( linkTypeID , RepositoryUser::getObjectTypeId( startObjectID ) )
             ;
  if( ! pre ) return 0;

  map<long , map< long , std::pair< std::pair<vector<long>* , vector<bool> * >  , long > > * >::iterator
      iter = linkedPartners1.find(linkTypeID),
      end  = linkedPartners1.end();
  if( iter != end ){//atrasts elements ar tadu linkTypeId
    assert( iter->second );
    map< long , std::pair< std::pair<vector<long> * , vector<bool> * >  , long > >::iterator
      iter2 = iter->second.first->find(startObjectID),
      end2  = iter->second.first->end();
    if (iter2 != end2){//atrast elements ar tadu startObjectId
      assert( iter2->second.first );
      if(iter2->second.second == currentSessionID() ){//ja partneri sanemti sis sesijas laika
        //atgriezam partnerus
        return iter2->second.first;
      }else{//partneris nav sanemts sis sesijas laika
        iter2->second.first->clear();             //izdzesam vecus partnerus
        //ieladejam jaunus partnerus
        populatePartnerList(iter2->second.first,linkTypeID,startObjectID);
        iter2->second.second=currentSessionID(); //atzimejam ieladesanas laiku
        return iter2->second.first;
      }
    }else{//elements ar tadu startObjID nav atrasts
      //ieladejam jaunu objektu
      vector<long> * partners = new vector<long>();
      bool inserted =iter->second->insert( make_pair(startObjectID,
                                                      make_pair(partners,
                                                                currentSessionID()
                                                                )
                                                      )
                                           ).second;
      assert( inserted );
      //ieladejam partnerus
      populatePartnerList(partners,linkTypeID,startObjectID);
      //ieladesanas laiks jau atzimets inside make_pair
      return partners;
    }
  }else{//iter==end
    //ieladejam jaunu associaciju
    vector<long> * partners = new vector<long>();
    std::pair< vector<long>* , long > partners_Timestamp(partners,currentSessionID());
    map<long , std::pair< vector<long>* , long > > * secCompon=
      new map<long , std::pair< vector<long>* , long > >();
    bool inserted =
      secCompon->insert(make_pair(startObjectID,partners_Timestamp)).second;
    assert( inserted );
    //ieladejam jaunu objektu
    bool inserted1 =
      linkedPartners1.insert( make_pair(linkTypeID , secCompon ) ).second;
    assert( inserted1 );
    //ieladejam jauna objekta partnerus
    populatePartnerList(partners,linkTypeID,startObjectID);
    //ieladesanas laiks atzimets inside make_pair
    return partners;
  }
}//
*/

LinkedPartnersIDListS::MyLinkedPartnersList *
LinkedPartnersIDListS::getPartners_2(long linkTypeID, long startObjectID){
  bool pre = RepositoryUser::objectExists( startObjectID ) &&
             RepositoryUser::assocExists( linkTypeID )     &&
             RepositoryUser::assocStartsFrom( linkTypeID , RepositoryUser::getObjectTypeId( startObjectID ) )
             ;
  if( ! pre ) return 0;

  map<long , map< long , std::pair< MyLinkedPartnersList *  , long > > * >::iterator
      iter = linkedPartners2.find(linkTypeID),
      end  = linkedPartners2.end();
  if( iter != end ){//atrasts elements ar tadu linkTypeId
    assert( iter->second );
    map< long , std::pair< MyLinkedPartnersList * , long > >::iterator
      iter2 = iter->second->find(startObjectID),
      end2  = iter->second->end();
    if (iter2 != end2){//atrast elements ar tadu startObjectId
      assert( iter2->second.first );
      if(iter2->second.second == currentSessionID() ){//ja partneri sanemti sis sesijas laika
        //atgriezam partnerus
        return iter2->second.first;
      }else{//partneris nav sanemts sis sesijas laika
        MyLinkedPartnersList * partners = iter2->second.first;
        partners->clear();             //izdzesam vecus partnerus
        //ieladejam jaunus partnerus
        partners->populateList(linkTypeID,startObjectID);
        iter2->second.second=currentSessionID(); //atzimejam ieladesanas laiku
        return iter2->second.first;
      }
    }else{//elements ar tadu startObjID nav atrasts
      //ieladejam jaunu objektu
      MyLinkedPartnersList * partners = new MyLinkedPartnersList();
      bool inserted =iter->second->insert( make_pair(startObjectID,
                                                      make_pair(partners,
                                                                currentSessionID()
                                                                )
                                                      )
                                           ).second;
      assert( inserted );
      //ieladejam partnerus
      //populatePartnerList(partners,linkTypeID,startObjectID);
      partners->populateList(linkTypeID,startObjectID);      
      //ieladesanas laiks jau atzimets inside make_pair
      return partners;
    }
  }else{//iter==end
    //ieladejam jaunu associaciju
    MyLinkedPartnersList * partners = new MyLinkedPartnersList();
    std::pair< MyLinkedPartnersList * , long > partners_Timestamp(partners,currentSessionID());
    map<long , std::pair< MyLinkedPartnersList * , long > > * secCompon=
      new map<long , std::pair< MyLinkedPartnersList * , long > >();
    bool inserted =
      secCompon->insert(make_pair(startObjectID,partners_Timestamp)).second;
    assert( inserted );
    //ieladejam jaunu objektu
    bool inserted1 =
      linkedPartners2.insert( make_pair(linkTypeID , secCompon ) ).second;
    assert( inserted1 );
    //ieladejam jauna objekta partnerus
    //populatePartnerList(partners,linkTypeID,startObjectID);
    partners->populateList(linkTypeID,startObjectID);
    //ieladesanas laiks atzimets inside make_pair
    return partners;
  }
}//





bool LinkedPartnersIDListS::createLink1(long linkTypeID , long startObjectID , long newPartnerID ){
  bool pre  = linkTypeID != 0 && startObjectID != 0 && newPartnerID !=0 ;
  assert(pre);
  int created=RepositoryUser::createLinkRaw(linkTypeID , startObjectID , newPartnerID );

  if ( created==0 ) ShowMessage ( "Can not create link.");
  assert(created);

  if(  existsRecord( linkTypeID , startObjectID ) ){
    MyLinkedPartnersList * partners = getPartners_2( linkTypeID , startObjectID );
    assert( partners );
    partners->addPartner( newPartnerID );
  }

  long invLinkTypeId = RepositoryUser::getAssociationInverse( linkTypeID );
  assert( invLinkTypeId );

  if(  existsRecord( invLinkTypeId , newPartnerID ) ){
    MyLinkedPartnersList * partners = getPartners_2( invLinkTypeId , newPartnerID );
    assert( partners );
    partners->addPartner( startObjectID );
  }
  return created;
}//

//bool LinkedPartnersIDListS::createLinkAfter(long linkTypeID , long startObjectID , long newPartnerID , long afterPartnerID){
//  bool pre  = linkTypeID != 0 && startObjectID != 0 && newPartnerID !=0 && afterPartnerID!=0;
//  assert(pre);
//  int created=RepositoryUser::createLinkAfterRaw(linkTypeID , startObjectID , newPartnerID , afterPartnerID);
//
//  if ( created==0 ) ShowMessage ( "Can not create link.");
//  assert(created);
//
//  if(  existsRecord( linkTypeID , startObjectID ) ){
//    vector<long> * partners = getPartners1( linkTypeID , startObjectID );
//    assert( partners );
//    partners->push_back(newPartnerID);
//  }
//
//  long invLinkTypeId = RepositoryUser::getAssociationInverse( linkTypeID );
//  assert( invLinkTypeId );
//
//  if(  existsRecord( invLinkTypeId , newPartnerID ) ){
//    vector<long> * partners = getPartners1( invLinkTypeId , newPartnerID );
//    assert( partners );
//    partners->push_back( startObjectID );
//  }
//  return created;
//}//





//void LinkedPartnersIDListS::addAssocID(long assocID){
//  bool alreadyThere = linkedPartners.count( assocID );
//  if( ! alreadyThere ){
//    std::map<long , vector<long> *  > *
//             startObjID_partners = new std::map< long , vector<long> * >();
//
//    std::pair<long , std::map<long , vector<long> *  > * >
//                             currPair( assocID , startObjID_partners);
//    bool inserted = linkedPartners.insert( make_pair( assocID , startObjID_partners ) ).second ;
//    assert(inserted);
//  }
//  //ja jau ielikts neko nedaram, aizvietot nedrikst!
//}//


//atgriez newPartnerId indeksu
long LinkedPartnersIDListS::addPartner(long linkTypeInd , long startObjectID , long newPartnerID )
{
  vector<long> * partnersList=getPartners(linkTypeInd , startObjectID);
  if ( partnersList ){
    partnersList->push_back(newPartnerID);
    return partnersList->size() - 1 ;
  }
  return badInd;
}//




//bool LinkedPartnersIDListS::putRecord( long linkTypeID , long startObjectID ){
//
//// vajadzetu izmantot if ( ! existEecord) putRecord
//
//  assert( ! existsRecord(linkTypeID,startObjectID) );
//
//  map<long , map< long , vector<long>* >* >::iterator
//      iter=linkedPartners.find(linkTypeID),
//      end=linkedPartners.end();
//
//  vector<long> * partners=new vector<long>();
//  populatePartnerList(partners,linkTypeID,startObjectID);
//  std::pair<long, vector<long>* > newRecord(startObjectID,partners);
//
//  if ( iter != end ){ //atrasts elements ar tadu linkTypeId
//    assert(iter->second->count(startObjectID) == 0 );  //nav elementa ar tadu startobjID
//    bool inserted=
//      iter->second->insert(newRecord).second;
//    assert(inserted);
//    //return true;
//    return inserted;
//  }else{
//    map<long , vector<long> * > *  toInsert= new map<long , vector<long> * >;
//    toInsert->insert(newRecord);
//    map<long , map< long , vector<long>* >* >::value_type toInsertMain(linkTypeID,toInsert);
//    bool insertResult=linkedPartners.insert(toInsertMain).second;
//    return insertResult;
//  }
//}//


bool LinkedPartnersIDListS::existsRecord(long linkTypeID , long startObjectID)
{
  //Jadarbojas ar linkedPartners1. neviss ar linkedPartners.
  map<long , map<long , std::pair< MyLinkedPartnersList *  , long > > * >::iterator
    iter = linkedPartners2.find(linkTypeID),
    end  = linkedPartners2.end();

  if ( iter != end ){//atrasts paris ar tadu linkTypeId
    assert( iter->second );
    map<long , std::pair< MyLinkedPartnersList * , long > >::iterator
      iter1 = iter->second->find( startObjectID ),
      end1  = iter->second->end();
    if( iter1 != end1 ){//atrast objekts ar tadu linkTypeID, un startObjID
      long timeStamp = iter1->second.second;
      if(  timeStamp == currentSessionID() )return true; //ir paris sanemts sis sessijas laika.
    }
  }
  return false;
}//


//string LinkedPartnersIDListS::print( ){
//  ostringstream res;
//  map<long , map<long , std::pair< vector<long>* , long > > * >::iterator
//    iter = linkedPartners1.begin(),
//    end  = linkedPartners1.end();
//  for(; iter != end ; ++iter){
//    res << iter->first << "  "<<endl;
//    map<long , std::pair< vector<long>* , long > >::iterator
//      iter1 = iter->second->begin(),
//      end1  = iter->second->end();
//    for( ; iter1 != end1 ; ++iter1){
//       res << "         " << iter1->first << "< [ ";
//       if(iter1->second.first){
//         long c = iter1->second.first->size();
//         for(long i =0; i < c ; i++){
//           res << iter1->second.first->at(i)<< " ";
//         }//
//       }//
//       res <<"] , "<< iter1->second.second << ">"<<endl;
//    }//
//  }//
//  return res.str();
//}//



/*
                  //linkTypeIndex nav tas pats kas linkTypeId
bool LinkedPartnersIDListS::existsRecordWhereLinkTypeID(long linkTypeID , long startObjectID)   //nav vajadziga
{
   assert(false);
   return false;
}//

neefektivi katru reizi ir jamekle vector<long> partersID, kurs atbilst <linktypeInd , startObjectID>

long LinkedPartnersIDListS::getPartnerIDByIndex( long linkTypeInd , long startObjectID , long partnerIndex )
{

}//


//-1 ja <linkTypeInd , startObjectID> neatrodas tabula
long LinkedPartnersIDListS::getPartnerCount(long linkTypeInd , long startObjectID)
{

}//
*/


void LinkedPartnersIDListS::populatePartnerList(vector<long> * partnersList, long linkTypeId, long startObjectId)
{
  if (partnersList){
    long count=RepositoryUser::getLinkedObjectNum(startObjectId, linkTypeId );
    partnersList->clear();
    //partnersList->reserve(count);// aizkomentets 12:56 23.10.2006.
    partnersList->reserve(count);// aizkomentets 12:56 23.10.2006.
    for (long i=0; i < count ; i++){
      long currPartnerId=RepositoryUser::getLinkedObjectIdByIndex(startObjectId,linkTypeId,i);
      partnersList->push_back( currPartnerId );
    }
  }
}

//vector<long> * ids;
//vector<bool> * skipId;

void LinkedPartnersIDListS::MyLinkedPartnersList::addPartner(long newPartnerId){
  assert( ids && skipId );
  for(unsigned int i=0; i < ids->size()  ; i++ ){
     if( ids->at(i) == newPartnerId ) skipId->at(i) = true;
  }
  ids->push_back( newPartnerId );
  skipId->push_back( false );
}

void LinkedPartnersIDListS::MyLinkedPartnersList::clear(){
  assert( ids && skipId );
  ids->clear();
  skipId->clear();
}

void LinkedPartnersIDListS::MyLinkedPartnersList::populateList(long assocID , long startObjID){
  assert( ids && skipId );
  long count = RepositoryUser::getLinkedObjectNum(startObjID, assocID );
    clear();
    ids->reserve(count);  skipId->reserve(count);
    for (long i=0; i < count ; i++){
      long currPartnerId=RepositoryUser::getLinkedObjectIdByIndex(startObjID,assocID,i);
      ids->push_back( currPartnerId );
      skipId->push_back( false );
    }
}

long LinkedPartnersIDListS::MyLinkedPartnersList::getVectorElemIndex(long vecElem){
  assert( ids && skipId );
  for (unsigned long i=0; i < ids->size() ; i++ ){
     if ( ids->at(i) == vecElem && ! skipId->at(i) ) return i;
  }
  return badInd;
}

LinkedPartnersIDListS::MyLinkedPartnersList::MyLinkedPartnersList(){
  ids = new vector<long>();
  skipId = new vector<bool>();
}

LinkedPartnersIDListS::MyLinkedPartnersList::~MyLinkedPartnersList(){
  delete ids; ids=0;
  delete skipId; skipId=0;
}





//
//
//
//
//
//
//
//   class Links
//
//
//


std::set<Links::pairOfLong> * Links::populateLinksSet(long linkTypeID){
  //ir linkTypeID
  //jasanem  set<objID1,objId2>

  std::set<Links::pairOfLong> * result = new   std::set<Links::pairOfLong>();
    //sanemam fromClassID
  long fromObjTypeId=RepositoryUser::getSideObjTypeId1(linkTypeID);
  long objCount=RepositoryUser::getObjectNum(fromObjTypeId);
  for(long i=0; i<objCount ;i++){
    long currObjID=RepositoryUser::getObjectIdByIndex(fromObjTypeId,i);
    long linkedObjCount=RepositoryUser::getLinkedObjectNum(currObjID,linkTypeID);
    for(long j=0; j<linkedObjCount ; j++){
       long currLinkedObjID=
          RepositoryUser::getLinkedObjectIdByIndex(currObjID,linkTypeID,j);
       bool inserted=
         result->insert(std::pair<long,long>(currObjID,currLinkedObjID)).second;
        ShowLink(linkTypeID,currObjID,currLinkedObjID);
       assert(inserted);
    }
  }
  return result;
}//


Links::Links(){
  //ShowMessage("Links::Links()");
  //initLinks();
  //ShowMessage("LInks initialized");
}//

void Links::initLinks(){

  vector<long> allLinkTypes; //visu aasociaciju ID
  RepositoryUser::getAllLinkTypes(& allLinkTypes);
  for (unsigned long i=0 ; i < allLinkTypes.size() ; i++){
    std::set<pairOfLong> * currLinksSet = populateLinksSet(allLinkTypes[i]);
    std::pair<long , std::set<pairOfLong> * >
                                    currPair( allLinkTypes[i], currLinksSet);
    bool inserted= mapOfLinksSet.insert( currPair ).second ;
    assert(inserted);
  }

  //for (long i=0; i< linkTypesCount_st ; i++){
  //  assert(linkTypes_st);
  //  std::set<pairOfLong> * currLinksSet = populateLinksSet(linkTypes_st[i]);
  //  linksSetArr[i]=currLinksSet;
  // }

}//

Links::~Links(){

  //std::map<long , std::set<pairOfLong> * >::iterator
  //  iter=mapOfLinksSet.begin(),
  //  end=mapOfLinksSet.end();
  //for( ; iter != end ; ++ iter ){
  //   delete iter->second;
  //}
  //ShowMessage("Links::~Links() destructor");
}//

Links & Links::instance(){
   static Links inst;
   return inst;
}//


/*//bool Links::addNewLink(long linkTypeID , long objID1, long objID2){
void Links::addNewLink(long linkTypeID , long objID1, long objID2){

   return; //return immediately!



   AnsiString o1Name=GetPropertyValue(objID1,1),
   o2Name=GetPropertyValue(objID2,1),
   assocName=GetTypeName(linkTypeID);


   //ShowMessage( Links::instance().print().c_str() );

   Links::pairOfLong p(objID1,objID2);
   if ( ! existsLink(linkTypeID , objID1, objID2)){
     assert( mapOfLinksSet.count(linkTypeID) );
     bool inserted=
       mapOfLinksSet[linkTypeID]->insert(p).second;
     if ( inserted){
           AnsiString msg("Link added \n:");
           msg+="obj1Name : "+o1Name+"\n";
           msg+="obj2Name : "+o2Name+"\n";
           msg+="assocName : "+assocName+"\n";
           //ShowMessage(msg);

           //ShowMessage( Links::instance().print().c_str() );

     }
     assert( inserted );
     //return inserted ;
   }

   AnsiString msg("Link Already exists \n:");
   msg+="obj1Name : "+o1Name+"\n";
   msg+="obj2Name : "+o2Name+"\n";
   msg+="assocName : "+assocName+"\n";
   //ShowMessage(msg);
   //return false;
}//
*/
/*
bool Links::deleteLink(long linkTypeID , long objID1, long objID2){

  return true;

   if ( mapOfLinksSet.count(linkTypeID) ){
     Links::pairOfLong p(objID1,objID2);
     bool erased = mapOfLinksSet[linkTypeID]->erase(p);

     long inverseLinkTypeId= GetInverseLinkTypeId(linkTypeID);
     assert(inverseLinkTypeId);
     Links::pairOfLong inverse_p(objID2,objID1);
     bool erasedInv = mapOfLinksSet[inverseLinkTypeId]->erase(inverse_p);

     return erased || erasedInv;
   }
   return false;
}//
*/

bool Links::existsLink(long linkTypeID , long objId1 ,long objId2) const{


  return RepositoryUser::linkExists( linkTypeID , objId1 , objId2 );
  /*





      //return AlreadyConnected( linkTypeID , objId1,objId2); /// vai stradatu atrak ar so ?

      Links::pairOfLong p(objId1,objId2);
      Links::pairOfLong inver_p(objId2,objId1);

      bool objIDsOk= RepositoryUser::objectExists(objId1) &&
                     RepositoryUser::objectExists(objId2);
      if ( !objIDsOk) return false;
      long inverLinkTypeID = RepositoryUser::getAssociationInverse(linkTypeID);
      if (inverLinkTypeID == 0 ) assert(false);

      bool foundDirect=false, foundInverse=false;
      std::map<long , std::set<pairOfLong> * >::const_iterator
        linkIter    = mapOfLinksSet.find(linkTypeID),
        invLinkIter = mapOfLinksSet.find(inverLinkTypeID),
        end         = mapOfLinksSet.end();

      if( linkIter != end ){
        std::set<pairOfLong> * curr = linkIter->second;
        if ( curr ){
          std::set<pairOfLong>::iterator
            iter = curr->find(p),
            end  = curr->end();
          foundDirect= ( iter != end );
        }else {  assert(false);}
      }
      if( invLinkIter != end ){
        std::set<pairOfLong> * curr = invLinkIter->second;
        if ( curr ){
          std::set<pairOfLong>::iterator
            iter = curr->find(inver_p),
            end  = curr->end();
          foundInverse= ( iter != end );
        }else {  assert(false);}
      }
      bool found = foundDirect || foundInverse;
      return found;
  */
}//

bool Links::existsLink_2(long linkTypeID , long objId1 ,long objId2) const{

  return RepositoryUser::linkExists( linkTypeID , objId1 , objId2 );
  /*




  //return AlreadyConnected( linkTypeID , objId1,objId2); /// vai stradatu atrak ar so ?
  //salidzinajuma ar to kas ir leja, neviss  augsa

      Links::pairOfLong p(objId1,objId2);
      Links::pairOfLong inver_p(objId2,objId1);

      bool objIDsOk= RepositoryUser::objectExists(objId1) &&
                     RepositoryUser::objectExists(objId2);
      if ( !objIDsOk) return false;
      long inverLinkTypeID = RepositoryUser::getAssociationInverse(linkTypeID);
      //if (inverLinkTypeID == 0 ) assert(false);

      bool foundDirect=false, foundInverse=false;
      std::map<long , std::set<pairOfLong> * >::const_iterator
        linkIter    = mapOfLinksSet.find(linkTypeID),
        invLinkIter = mapOfLinksSet.find(inverLinkTypeID),
        end         = mapOfLinksSet.end();

      if( linkIter != end ){
        std::set<pairOfLong> * curr = linkIter->second;
        if ( curr ){
          std::set<pairOfLong>::iterator
            iter = curr->find(p),
            end  = curr->end();
          foundDirect= ( iter != end );
        }else{//  assert(false);
        }
      }
      if( invLinkIter != end ){
        std::set<pairOfLong> * curr = invLinkIter->second;
        if ( curr ){
          std::set<pairOfLong>::iterator
            iter = curr->find(inver_p),
            end  = curr->end();
          foundInverse= ( iter != end );
        }else{  //assert(false);
        }
      }
      bool found = foundDirect || foundInverse;
      return found;
  */
}//

string Links::print(){
   std::map<long , std::set<Links::pairOfLong> * >::iterator
     iter=mapOfLinksSet.begin(),
     end=mapOfLinksSet.end();
   string result=" *** Links *** \n";
   for( ; iter != end ; ++iter ){
     long assocID = iter->first;
     result+= IntToStr(assocID).c_str();
     result+="\n";
     //drukajam <objId1,objId2>
     std::set<pairOfLong> * curr= iter->second;
     if ( curr ){
       std::set<pairOfLong>::iterator
         pairsIter = curr->begin(),
         pairsEnd = curr->end() ;
       for( ; pairsIter != pairsEnd ; ++pairsIter ){
          result+="\t < " + string(IntToStr(pairsIter->first).c_str())+ " , " +
                           string(IntToStr(pairsIter->second).c_str())+" > \n" ;
       }
     }else{ assert(false);}
   }

   return result;
}//










//
//
//
// class RepositoryChangeListener{
//
//
//

RepositoryChangeListener::RepositoryChangeListener()
{
}//do nothing

RepositoryChangeListener::~RepositoryChangeListener()
{
}//do nothing

//  std::map< long , vector< long > >::const_iterator
//    it = changedInstances.begin(),
//    end = changedInstances.end();
//  for( ; it != end ; ++it ){
//
//  }

RepositoryChangeListener & RepositoryChangeListener::instance(){
 static RepositoryChangeListener instance;
 return instance;
}//

void RepositoryChangeListener::addChangedInstance( long objId ){
  long objClassId = RepositoryUser::getObjectTypeId( objId );
  addChangedInstance( objId , objClassId );

  //assert ( objClassId > 0 );
  //map<long , vector<long> >::const_iterator
  //    it = changedInstances.find( objClassId );
  //if( it != changedInstances.end() ){ // vai objId pieder Monitored class
  //    changedInstances[ objClassId ].push_back( objId );
  //}
  
}//

void RepositoryChangeListener::addChangedInstance( long objId , long  thisObjClassId ){
  assert ( thisObjClassId > 0 );
  map<long , vector<long> >::iterator
      it = changedInstances.find( thisObjClassId );
  if( it != changedInstances.end() ){ // vai objId pieder Monitored class
      it->second.push_back( objId );
  }
}//


// papildus varetu but classID , classInd
void RepositoryChangeListener::objectDeleted(long objId , long thisObjClassId ){
  addChangedInstance( objId , thisObjClassId );
  deletedObjects.push_back(objId);
}//

// papildus varetu but classID , classInd
void RepositoryChangeListener::objectCreated(long objId){
  addChangedInstance( objId );
}//

void RepositoryChangeListener::linkDeleted(long /*linkTypeID*/ , long objId1 , long objId2){
  addChangedInstance( objId1 );
  addChangedInstance( objId2 );
}//

void RepositoryChangeListener::linkCreated(long /*linkTypeID*/ , long objId1 , long objId2){
  addChangedInstance( objId1 );
  addChangedInstance( objId2 );
}//

//pamainijas vai bija uzstadita seansa laika
void RepositoryChangeListener::attributeValueSet(long objId , long /*attrId*/, const WideString & /*attrVal*/ ){
  addChangedInstance( objId );
}//


void RepositoryChangeListener::getChangedInstances( vector<long> & result ){
  std::map< long , vector< long > >::const_iterator
    mapIt  = changedInstances.begin(),
    mapEnd = changedInstances.end();
  for( ; mapIt != mapEnd ; ++mapIt){
    result.insert( result.end(),
                   mapIt->second.begin(), mapIt->second.end() );
  }//for
}//

const vector<long> & RepositoryChangeListener::getDeletedObjects(){
  return deletedObjects;
} 

void RepositoryChangeListener::setMonitoredClasses( vector< long > const & monitoredClasses ){
  //izmetam tos kuri jau bija
  //ieliekam tos kuri vel nebija
  //liekot to klasi, kurai ir

  //monitoredClasses + apaksklases no katra no monitoredClasses
  std::set< long > monitoredClassesClosure;
  for(unsigned  int i = 0 ; i < monitoredClasses.size() ; i++ ){
    long currClassId = monitoredClasses[i];
    vector< long > * currClassSubClasses =
        RepositoryUser::getAllSubClassesID( currClassId );
      if( currClassSubClasses ){
        monitoredClassesClosure.insert( (*currClassSubClasses).begin(),
                                       (*currClassSubClasses).end()
                                       );
      }//if
    delete currClassSubClasses; currClassSubClasses = 0;
  }//for

  std::set< long >::const_iterator
    setIt  = monitoredClassesClosure.begin(),
    setEnd = monitoredClassesClosure.end();
  std::map< long , vector< long > >::iterator
    mapIt  = changedInstances.begin(),
    mapEnd = changedInstances.end();

  //monitoredClassesClosure un changedInstances ir sakartoti pec pirmas komponentes
  //paraleli ejam pa siem sarakstiem

  for( ; setIt != setEnd ; ++setIt){
    //if( setIt == setEnd ){
    //      ShowMessage( " setIt == setEnd is true");
    //}else ShowMessage( " setIt == setEnd is false");

    //printIntSet( monitoredClassesClosure );

    while( ( mapIt != mapEnd ) &&  ( *setIt != mapIt->first ) ){
      mapIt->second.clear(); //aizmirsam instances
      //un iznicinam so klasi
      std::map< long , vector< long > >::iterator toDelete = mapIt;
      ++mapIt;
      if( ! changedInstances.empty() ){
        changedInstances.erase( toDelete );
      }
    }
    if( mapIt != mapEnd ){
      mapIt->second.clear();
    }else{ //pievienojam map`am visus tos elementus, kuri ir aiz setIt

      //printIntSet( monitoredClassesClosure );

      for( ; setIt != setEnd ; ++setIt ){
          //if( setIt == setEnd ){
          //  ShowMessage( " setIt == setEnd is true");
          //}else ShowMessage( " setIt == setEnd is false");

        vector< long > emptyVector;
        long currClassId = * setIt ;
        std::pair< long , vector<long> > toInsert( currClassId , emptyVector );
        changedInstances.insert( toInsert );
      }//for
      break;
    }
  }//for
}//


//
//
// F-jas darbibam ar MM
//
//

//sanem kvalificetu vardu
//izdod lokalo MM elementa vardu
//un tas pakotnes Id kura sis elements ir jaieliek,
//ja kada no pakotnem neeksiste veido to
//pckIdOut  glaba pedejas pakotnes Id
//vai ari 0 ja pakotnes vards bija tukss
static
bool processQualifiedName( const string & qname , string & pureNameOut , long & pckIdOut ){
    vector< string > qualifiers;
    string pureMMElemName;
    StrRoutine::splitQName( qname , qualifiers , pureMMElemName );

    long lastPckId=0;
    string previousQualifiersStr;

    for(unsigned int i=0; i < qualifiers.size() ; i++ ){
      string currQualifierStr = qualifiers[i];
      long pckId = RepositoryUser::getPackageIdByName( (previousQualifiersStr + currQualifierStr).c_str() );
      if( ! pckId ){//package does not exist
        //pckId = RepositoryUser::CreatePackage( currQualifierStr.c_str() , "" , 0 );
        pckId = RepositoryUser::createPackage( currQualifierStr );
        if( !pckId ){
          ShowMessage( ("Can not create package \""+currQualifierStr+"\".").c_str() );
          return false;
        }
        if( lastPckId ){//nav pirma pakotne
          int placedOk = RepositoryUser::setPackage( pckId , lastPckId );
          if(!placedOk){
            string s="Can not place package \""+currQualifierStr+"\" to package\"";
            //s+=AnsiString(RepositoryUser::getTypeName(lastPckId)).c_str();
            s+=RepositoryUser::getTypeName(lastPckId);
            s+="\".";
            ShowMessage( s.c_str());
            return false;
          }
        }else{//pirma pakotne ( pati kreisaka ) //nekur nav jaliek
        }
      }else{//package already exists
        //neko nedaram
      }
      lastPckId = pckId ;
      previousQualifiersStr += currQualifierStr + "::";
    }//
    pckIdOut = lastPckId;
    pureNameOut = pureMMElemName;
    return true;
}//

static
void placeMMElemToPck( long mmElemId , char mmElemKind, long pckId){
  assert( mmElemId );
  if( pckId ){
       int placedOk = RepositoryUser::setPackage( mmElemId , pckId );
       if(!placedOk){
         string s="Can not place ";
         switch( mmElemKind ){
           case 'c' : s+="class";       break;
           case 'a' : s+="attribute";   break;
           case 'l' : s+="association"; break;
           default : assert( !"Illegal mmElemKind.");
         }
         s+="\"";
         //s+=AnsiString(GetTypeName(mmElemId)).c_str();
         s+=RepositoryUser::getTypeName(mmElemId);
         s+="\" to package\"";
         //s+=AnsiString(GetTypeName(pckId)).c_str();
         s+=RepositoryUser::getTypeName(pckId);
         s+="\".";
         ShowMessage( s.c_str());
      }
  }
}//

static
void AssocWasNotCreated(const string & subjRoleName ,const string & objRoleName ,
                       const string & subjClassName,const string & objClassName )
{

    stringstream s;
    s<<"Association \""<<subjRoleName<<"\"/\""<<objRoleName
    << "\" between classes \""<<subjClassName<<"\" \""<<objClassName<<"\""<<" was not created.";
    AnsiString msg =  s.str().c_str();
    ShowMessage( msg );
}//

void CreateClass( const string & className ){
  if( className.empty() ){
    ShowMessage( "Class name can not be empty." );
    return;
  }
  long classID = RepositoryUser::getClassIdByName( className );

  if( classID ){
    //klase jau eksiste
    AnsiString msg = "Class \"";
    msg+=  className.c_str();      msg+=  "\" already exists.";
    ShowMessage( msg );
  }else{
    //
    string pureClassName;
    long lastPckId=0;
    bool processedOk = processQualifiedName( className , pureClassName , lastPckId );
    if( ! processedOk )return;

    if( pureClassName.empty() ){
      ShowMessage( "Class name can not be empty." );
      return;
    }

    long newClID = RepositoryUser::createClass(pureClassName);
    //long newClID = CreateObjectType1( 0 , pureClassName.c_str() , "" , "" , "" ,0,"", 0 , 0);
    //if( ! newClID ){
    //  AnsiString msg = "Class \"";
    //  msg+=  className.c_str();      msg+=  "\" was not created.";
    //  ShowMessage( msg );
    //  return;
    //}else{
    //  //L0_ObjectIDListS::instance().addClassID( newClID );
    //}

    placeMMElemToPck( newClID, 'c',lastPckId);
  }
}//

void DeleteClass( const string & className ){
  long classID = RepositoryUser::getClassIdByName( className );
  if( ! classID ) return;
  RepositoryUser::deleteClass( classID );
  return;
  //All error processing is done inside DeleteObjectType including messaging
  //if( ! CanDeleteObjectType( classID , 0 ) ){
  //  AnsiString msg = "Can not delete class ";
  //  msg+="\"";
  //  msg+=className.c_str();
  //  msg+="\".";
  //  ShowMessage( msg );
  //}else{
  //  int deleted = DeleteObjectType( classID );
  //  assert( deleted );
  //}
}//



void CreateAttrConnectedToClassXXX( const string & className , const string & attrName ,
                                 char baseType_prm) //baseType from ect_data_api.h
{
  long classId = RepositoryUser::getClassIdByName( className );
  if( classId != 0 ){
    long attrID = RepositoryUser::getAttributeIdByName( 0 , attrName.c_str() );
    if( attrID != 0 ){
       enum baseType attrT = RepositoryUser::getAttributeType( attrID );
       bool attrTypesCoincide = RepositoryUser::equalsBaseTypeMyBaseTypeEBM(attrT , baseType_prm) ;
       if( attrTypesCoincide ){
         return;
       }else{
         ostringstream o;
         o << "Conflicting attribute types \n"
           << "Required "<< className<<" : " << attrName << " : " << attrT
           << "\nBut "<<attrName<< " already exists and its type is "<<attrT;
         ShowMessage( o.str().c_str() );
       }
    }else{
      //veidojam jaunu
      CreateAttr( attrName , baseType_prm );
      AddAttr( attrName , className );
    }
  }else{
    ostringstream o;
    o << "Class \""<<className<<"\" does not exist.\n"<<"Can not connect attribute \""<< attrName<<"\".";
    ShowMessage( o.str().c_str() );
  }
}//

//void CreateAttrConnectedToClass2( const string & className , const string & attrName ,
//                                 char baseType_prm) //baseType from ect_data_api.h
//{
//  long classId = RepositoryUser::getClassIdByName( className );
//  if( classId != 0 ){
//    long attrID = RepositoryUser::getAttributeIdByName( classId , attrName.c_str() );
//    if( attrID == 0){//veidojam jaunu attributu
//      attrID = CreateAttr( attrName , baseType_prm);
//      if( attrID == 0) return;
//    }else{//jau eksiste attr ar tadu pati vardu un sis attr ir piesaistits musu className
//      //tatad vardi sakrit ja tipi ari sakrti izejam
//      //
//
//    }
//  }
//}//

/*
klase ir , klasei ir attr ar sadu vardu, klasei piesaistita attribta tips sakrit ar mums velamo
klase ir , klasei ir attr ar sadu vardu, klasei piesaistita attribta tips NEsakrit ar mums velamo
klase ir , klasei NAV attr ar sadu vardu
klase nav,
*/
void CreateAttrConnectedToClass( const string & className , const string & attrName ,
                                 char baseType_prm) //baseType from ect_data_api.h
{
  long classId = RepositoryUser::getClassIdByName( className );
  bool classExists = classId != 0;
  if( classExists ){
    long attrID = RepositoryUser::getAttributeIdByName( classId , attrName.c_str() );
    bool attrIsConnToCl = attrID != 0;
    if( attrIsConnToCl ){
      enum baseType piesaistAttrTips = RepositoryUser::getAttributeType( attrID );
      bool tipiSakrit = RepositoryUser::equalsBaseTypeMyBaseTypeEBM(piesaistAttrTips, baseType_prm) ;
      if (tipiSakrit) {
         return; // nekas nav jadara
      }else{
         ostringstream o;
         o <<  "Error. Incompatible attribute types." <<endl
         <<"Class \""<< className << "\" already has attribute \""<<attrName
         << ".\n Attribute type redefinition requested.";
         ShowMessage(o.str().c_str());
      }
    }else{
      long attrID_glob = RepositoryUser::getAttributeIdByName( 0 , attrName.c_str() );
      bool eksistGlobAttr = attrID_glob != 0;
      if( eksistGlobAttr ){
        enum baseType globAttrTips = RepositoryUser::getAttributeType( attrID_glob );
        bool tipiSakritGlob = RepositoryUser::equalsBaseTypeMyBaseTypeEBM( globAttrTips , baseType_prm) ;
        if( tipiSakritGlob ){
          AddAttr(attrName,className);
          return;
        }else{
          ostringstream o;
          o<<"Error. Incompatible attribute types." <<endl
          <<"Global attribute \""<<attrName<<"\" type redefinition requested.";
          ShowMessage(o.str().c_str());
        }
      }else{
        CreateAttr( attrName , baseType_prm );
        AddAttr( attrName , className );
      }
    }
  }else{//klase neeksiste
    ostringstream o ;
    o << classDoesNotExist1( className ) << "\n Can not connect attribute \""<< attrName << "\".";
    ShowMessage(o.str().c_str());
  }
}//

void CreateAttrConnectedToClass( const string & className , const string & attrName ,
                                 const string &  baseTypeName)
{
  CreateAttrConnectedToClass( className, attrName ,
                              RepositoryUser::getEBMTypeCodeByName(baseTypeName)
                             );
}



void CreateAttr( const string & attrName , char baseType_prm){
  //assert( baseType == BaseType_STRING || baseType == BaseType_INTEGER ||
  //        baseType == BaseType_FLOAT || baseType == BaseType_BOOLEAN
  //       );
  assert( RepositoryUser::isElementaryBaseType(baseType_prm) );
  long propTypeID = RepositoryUser::getAttributeIdByName( 0 , attrName.c_str() );
  if( propTypeID ){
    AnsiString msg = "Attribute \"";
    msg+=  attrName.c_str();      msg+=  "\" already exists.";
    ShowMessage( msg );
  }else{
    string pureAttrName;
    long lastPckId=0;
    bool processedOk = processQualifiedName( attrName , pureAttrName , lastPckId );
    if( ! processedOk )return;

    if( pureAttrName.empty() ){
      ShowMessage("Attribute name can not be empty");
      return;
    }

    //long newAttrID = CreatePropertyType( pureAttrName.c_str() , "" , baseType, 1 , "" , "" );
    long newAttrID = RepositoryUser::createAttr( pureAttrName , baseType_prm );
    if( ! newAttrID ){
      AnsiString msg = "Attribute \"";
      msg+=  attrName.c_str();      msg+=  "\" was not created.";
      ShowMessage( msg );
      return;
    }else placeMMElemToPck( newAttrID, 'a' , lastPckId );
  }
}//


void createEnumerationAttr(const string & /*attrName*/ , const vector<const string> & /*enumElems*/){
   /* TODO : implement void createEnumerationAttr(const string & attrName , const vector<const string> & enumElems){ */
  assert( !"Not implemented" );
}//

void DeleteAttr( const string & attrName ){
  long attrID = RepositoryUser::getAttributeIdByName( 0 , attrName.c_str() );
  if( ! attrID ) return;
  //DeletePropertyType( attrID );
  RepositoryUser::deleteAttr( attrID );
  //All error processing is inside DeletePropertyType
  //if( ! CanDeletePropertyType( attrID , 0 ) ){
  //  AnsiString msg = "Can not delete attribute ";
  //  msg+="\"";
  //  msg+= attrName.c_str();
  //  msg+="\".";
  //  ShowMessage( msg );
  //}else{
  //  int deleted = DeletePropertyType( attrID );
  //  assert( deleted );
  //}
}//

void AddAttr( const string & attrName , const string & className){
  long classID = RepositoryUser::getClassIdByName( className );
  if( ! classID ){
    ShowClassDoesNotExist( className );
    return;
  }
  long attrID = RepositoryUser::getAttributeIdByName( 0 , attrName.c_str() );
  if( ! attrID ){
    AnsiString msg = "Attribute \"";
    msg+=  attrName.c_str();      msg+=  "\" does not exist.";
    ShowMessage( msg );
    return;
  }
  int added = RepositoryUser::addAttr(  attrID , classID );
  if( ! added ){
    AnsiString msg = "Attribute \"";
    msg+=  attrName.c_str();      msg+=  "\" was not added to class \"";
    msg+=className.c_str();
    msg+="\"." ;
    ShowMessage( msg );
    return;
  }
}//

void RemoveAttr( const string & attrName , const string & className){
  long classID = RepositoryUser::getClassIdByName( className );
  if( ! classID ){
    ShowClassDoesNotExist( className );
    return;
  }
  long attrID = RepositoryUser::getAttributeIdByName( 0 , attrName.c_str() );
  if( ! attrID ){
    AnsiString msg = "Attribute \"";
    msg+=  attrName.c_str();      msg+=  "\" does not exist.";
    ShowMessage( msg );
    return;
  }
  //int removed = RemovePropertyType( classID , attrID );
  int removed = RepositoryUser::removeAttr( classID , attrID );
  if( ! removed ){
    AnsiString msg = "Attribute \"";
    msg+=  attrName.c_str();      msg+=  "\" was not removed from class \"";
    msg+=className.c_str();
    msg+="\"." ;
    ShowMessage( msg );
    return;
  }
}//


inline
static bool cardOk(char c){
  //bool ok =  c == Card_01 ||  c == Card_0N || c ==Card_1 || c == Card_1N;
  //return ok;
  return RepositoryUser::isCardinality(c);
}//

static void createAssocZZZ( const string & subjClassName, const string & subjRoleName,
                            char subjEndCard,
                            const string & objClassName, const string & objRoleName,
                            char objEndCard,
                            bool isComposition,
                            bool fromIsOrdered, bool toIsOrdered
                            )
{
  bool cardOK = cardOk( subjEndCard ) && cardOk( objEndCard );
  assert( cardOK );
  long subjClID = RepositoryUser::getClassIdByName( subjClassName );
  if( ! subjClID ){
    ShowClassDoesNotExist( subjClassName );
    return;
  }

  long objClID = RepositoryUser::getClassIdByName( objClassName );
  if( ! objClID ){
    ShowClassDoesNotExist( objClassName );
    return;
  }

  bool bothRoleNamesEmpty = subjRoleName.empty() && objRoleName.empty();
  if( bothRoleNamesEmpty ){
    ShowMessage( "At least one role name must not be empty." );
    AssocWasNotCreated(subjRoleName, objRoleName, subjClassName, objClassName);
    return;
  }

  string pureSubjRoleName,pureObjRoleName;
  long lastSubjPckId=0,lastObjPckId=0;
  bool subjProcessedOk = processQualifiedName( subjRoleName , pureSubjRoleName , lastSubjPckId ),
       objProcessedOk = processQualifiedName( objRoleName , pureObjRoleName , lastObjPckId );

  if( ! subjRoleName.empty() && ! objRoleName.empty() ){
    if( ! subjProcessedOk || ! objProcessedOk){
      AssocWasNotCreated(subjRoleName, objRoleName, subjClassName, objClassName);
      return;
	}
    if(  lastSubjPckId != lastObjPckId ){
      ShowMessage( "Assoc and inverse assoc can not be placed in different packages.");
      AssocWasNotCreated(subjRoleName, objRoleName, subjClassName, objClassName);
      return;
    }
  }

  if( pureSubjRoleName.empty() && pureObjRoleName.empty() ){
    ShowMessage( "At least one role name must not be empty." );
    AssocWasNotCreated(subjRoleName, objRoleName, subjClassName, objClassName);
    return;
  }

  //char objTypeRole, subjTypeRole;
  //if( isComposition ){
  //  objTypeRole  = Role_Part;
  //  subjTypeRole = Role_Aggregate;
  //}else{
  //  objTypeRole  = subjTypeRole = Role_IndependentPartner;
  //}

  long assocID = RepositoryUser::getAssociationIdByName( subjClID , subjRoleName.c_str());
  if( assocID ){
    AssocWasNotCreated(subjRoleName, objRoleName, subjClassName, objClassName);
    return;
  }

  long newAssocID = 0;
       //CreateLinkType1( pureSubjRoleName.c_str() , "" , pureObjRoleName.c_str() ,
       //                 subjClID, subjEndCard , subjTypeRole,
       //                 objClID, objEndCard, objTypeRole,
       //                 "","","",0);
  if( isComposition ){
     newAssocID = RepositoryUser::createComposition(pureSubjRoleName.c_str() , pureObjRoleName.c_str() ,
                        subjClID, subjEndCard ,
                        objClID, objEndCard,
                        fromIsOrdered, toIsOrdered );
  }else{
     newAssocID = RepositoryUser::createAssociation(pureSubjRoleName.c_str() , pureObjRoleName.c_str() ,
						subjClID, subjEndCard ,
                                                objClID, objEndCard,
                                                fromIsOrdered, toIsOrdered  );

  }

  if( ! newAssocID ){
    AssocWasNotCreated(subjRoleName, objRoleName, subjClassName, objClassName);
  }else{
    long pckID=0;
    if( lastSubjPckId == 0 && lastObjPckId == 0 )pckID=0;
    else pckID = lastSubjPckId ? lastSubjPckId : lastObjPckId;

    placeMMElemToPck( newAssocID , 'l' , pckID );
    //add info about new assoc into L0 runtime stuctures
    /* TODO : complete implementation of this function.
           //  Not necessary .
           //There will be two diferent processes ; one for L0 programs , one for L0 MM modifying
    */

  }
}//

void CreateAssociation( const string & subjClassName, const string & subjRoleName,
                        char subjEndCard,
                        const string & objClassName, const string & objRoleName,
                        char objEndCard,
                        bool fromIsOrdered, bool toIsOrdered)
{
   createAssocZZZ( subjClassName, subjRoleName,subjEndCard,
                   objClassName, objRoleName, objEndCard,
                   false,
                   fromIsOrdered, toIsOrdered
                  );
}//

void CreateComposition(const string & subjClassName, const string & subjRoleName,
                        char subjEndCard,
                        const string & objClassName, const string & objRoleName,
                        char objEndCard,
                        bool fromIsOrdered, bool toIsOrdered )
{
   createAssocZZZ( subjClassName, subjRoleName,subjEndCard,
		   objClassName, objRoleName, objEndCard,
                   true,
                   fromIsOrdered, toIsOrdered
                  );

}//

void DeleteAssociation(const string & subjClassName, const string & objRoleName,
                       const string & objClassName)
{
  long subjClID = RepositoryUser::getClassIdByName( subjClassName );
  if( ! subjClID ){
    ShowClassDoesNotExist( subjClassName );
    return;
  }
  long objClID = RepositoryUser::getClassIdByName( objClassName );
  if( ! objClID ){
    ShowClassDoesNotExist( objClassName );
    return;
  }
  long assocID = RepositoryUser::getAssociationIdByName( subjClID , objRoleName.c_str() );
  if( ! assocID ) return;
  RepositoryUser::deleteAssociation( assocID );
  //if( ! CanDeleteLinkType( assocID , 0 ) ){
  //  stringstream s;
  //  s<<"Can not delete association \""
  //                                    //<<subjRoleName<<"/"
  //                                    <<objRoleName
  //  << "\" between classes \""<<subjClassName<<"\" \""<<objClassName<<"\""<<" .";
  //  AnsiString msg =  s.str().c_str();
  // ShowMessage( msg );
  //}else{
  //  int deleted = DeleteLinkType( assocID );
  //  assert( deleted );
  //}
}//

//sets derived as extension of base
void CreateGeneralization( const string & baseName , const string &derivedName ){
  long baseID = RepositoryUser::getClassIdByName( baseName.c_str() );
  long derivedID = RepositoryUser::getClassIdByName( derivedName.c_str() );
  if( ! baseID ){
    ShowClassDoesNotExist( baseName );
    return;
  }
  if( ! derivedID ){
    ShowClassDoesNotExist( derivedName );
    return;
  }
  //string pureName; vector<string> v;
  //StrRoutine::splitQName(derivedName ,v, pureName);

  //int updatedOk = UpdateObjectType( baseID , derivedID , pureName.c_str() , "" , "" , "");
  int updatedOk = RepositoryUser::createGeneralization(baseID,derivedID);
  if( ! updatedOk ){
    stringstream s;
    s << "Generalization between classes \"" << baseName << "\" \""
      <<derivedName<<"\" was not created.";
    ShowMessage( s.str().c_str() );
  }
}//

void DeleteGeneralization( const string & baseName , const string & derivedName ){
  long baseID = RepositoryUser::getClassIdByName( baseName.c_str() );
  long derivedID = RepositoryUser::getClassIdByName( derivedName.c_str() );
  if( ! baseID ){
    ShowClassDoesNotExist( baseName );
    return;
  }
  if( ! derivedID ){
    ShowClassDoesNotExist( derivedName );
    return;
  }

  //string pureName; vector<string> v;
  //StrRoutine::splitQName(derivedName ,v, pureName);

  //int updatedOk = UpdateObjectType( 0 , derivedID , pureName.c_str() , "" , "" , "");
  int updatedOk = RepositoryUser::deleteGeneralization(baseID,derivedID);
  if( ! updatedOk ){
    string s = "Generalization between classes \"" + baseName +"\" "+derivedName+"\" was not deleted.";
    ShowMessage(s.c_str());
  }
}//

void CreateEnum(const string & enumName , const string * enumLiterals, int enumLiteralCount ){
  long enumID = RepositoryUser::getAttributeIdByName(0 , enumName.c_str());
  if(enumID){
    string msg;
    msg+= "Attribute with name \""+ enumName+ "\" already exists.\n";
    msg+= "Enumeration \"" + enumName + "\" was not created.";
    ShowMessage( msg.c_str() );
    return;
  }else{
    //veidojam enumu atbilstosaja pakotne
    string pureAttrName;
    long lastPckId=0;
    bool processedOk = processQualifiedName( enumName , pureAttrName , lastPckId );
    if( ! processedOk ){
      string msg;
      msg+= "Enumeration \"" + enumName + "\" was not created.";
      ShowMessage( msg.c_str() );
     return;
    }

    if( pureAttrName.empty() ){
      ShowMessage("Enumeration name can not be empty.");
      return;
    }

    long newAttrID = RepositoryUser::createEnum( pureAttrName );
    if( ! newAttrID ){
      AnsiString msg = "Enumeration \"";
      msg+=  enumName.c_str();      msg+=  "\" was not created.";
      ShowMessage( msg );
      return;
	}else{
	   placeMMElemToPck( newAttrID, 'a' , lastPckId );
	   //pievienojam elementus
	   for(int i=0 ; i < enumLiteralCount; i++){
		 string s(enumLiterals[i]);
		 RepositoryUser::addEnumLiteralToEnum( newAttrID , s );
	   }
	}
  }
}//


/* TODO : implement them */
//atkabina enum no klasem kur tas tiek izmantots un iznicina
void DeleteEnum(const string & enumName){
  vector<long> classes;
  RepositoryUser::getAllClasses( classes );
  for(unsigned int i=0; i < classes.size() ; i++ ){
     long currClassID = classes.at(i);
     bool isConnected = RepositoryUser::existsAttribute(
                          RepositoryUser::getClassName(currClassID),
                          enumName );
     if( isConnected ){
       RemoveAttr( enumName , RepositoryUser::getClassName(currClassID) );
     }
  }
  DeleteAttr(enumName);
}

void AddEnumElem(const string & enumElemName, const string & enumName){
  long enumID = RepositoryUser::getAttributeIdByName( 0 , enumName.c_str() );
  if( ! enumID ){
    string msg = "Enumeration \"" +enumName +"\" does not exist.";
    ShowErrMsg( msg );
  }
  RepositoryUser::addEnumLiteralToEnum(enumID , enumElemName );
}

void DeleteEnumElem(const string & /*enumElemName*/, const string & /*enumName*/){
  assert(! "Not implemented." );
   /* TODO :
    *  Implement  function DeleteEnumElem, when it will be possible .
    *  Implementation was postponed, because repo did not have corresponding
    *  functions.
    */
}



class IsSuitable{
  public : virtual bool operator()(long ID)const=0 ;
};

class ClassCheck : public IsSuitable{
  public:
  virtual bool operator()(long ID)const{ return RepositoryUser::classExists( ID ); }
};

class SubClassCheck : public ClassCheck{};

class AttrCheck : public IsSuitable{
  public:
  string className;
  virtual bool operator()(long ID)const{
	return RepositoryUser::existsAttribute( className ,
                                                RepositoryUser::getTypeName(ID) );
  }
  AttrCheck(const string & in ):className(in){}
};

class AttrDirectCheck : public AttrCheck{
  public:
  AttrDirectCheck(const string & in ):AttrCheck(in){}
};

class EnumCheck : public IsSuitable{
  public:
  virtual bool operator()(long ID)const{
	return RepositoryUser::existsEnum( RepositoryUser::getTypeName(ID) );
  }
};

class AssocCheck : public IsSuitable{
  public:
  virtual bool operator()(long ID)const{ return RepositoryUser::assocExists( ID );}
};

class AssocDirectCheck : public AssocCheck{};

//
//
//
//      class MMElemIter{
//
//
//


void prepareMap( std::map< string , std::pair < TList * , int > > & m ,
		 const string & MMElemName , TList * list )
{
  std::map< string , std::pair < TList* , int > >::iterator
    it = m.find( MMElemName );
  if( it != m.end() ){ //ja sis klases apaksklases jau skatamies
	TList * oldList = it->second.first;

	delete oldList;	it->second.first = 0;

	m.erase( it );
  }

  assert( m.count( MMElemName ) == 0 );

  //ieladejam jaunu sarakstu, saraksta ind uz -1
  std::pair<TList * , int > p( list , -1 );
  m.insert(std::make_pair(MMElemName, p ) );
}

bool listReady( std::map< string , std::pair < TList * , int > > & m ,
		const string & MMElemName ,
		std::map< string , std::pair < TList * , int > >::iterator & it )
{
  it = m.find( MMElemName );
  if( it == m.end() ) return false;
  if( it->second.first == 0  ) return false;
  if( it->second.second >= it->second.first->Count ) return false;//currInd >= elemCount
  return true;
}

void clearMap( std::map< string , std::pair<TList * , int > > & m  ){
  std::map< string , std::pair<TList * , int > >::iterator
    it = m.begin(), end = m.end();
  for( ; it != end ; ++it){
    TList * l = it->second.first;
    delete l;
  }
}

long getNextListElem(TList  * const  list, int & currInd, const IsSuitable & oracle ){
  if( list == 0 ) return -1;
  if( currInd >= list->Count ) return -1;

  currInd++;

  for( ; currInd < list->Count ; currInd++ ){
	long currElem =(long)(list->Items[currInd]);
	if( oracle ( currElem ) ) return currElem;
  }
  return -1;
}


long getNextElem( std::map< string , std::pair < TList* , int > > & m ,
		  const  string & name , const IsSuitable & oracle )
{
  std::map< string , std::pair < TList* , int > >::iterator it;
  if( ! listReady( m , name , it ) ) return -1;

  //const int & elemCount = it->second.first->Count;
  int & currInd  = it->second.second;
  TList * & list= it->second.first;

//  currInd++;
//
//  for( ; currInd < elemCount ; currInd++ ){
//	long currElem =(long)(list->Items[currInd]);
//	if( oracle ( currElem ) ) return currElem;
//  }
//  return -1;
  return getNextListElem(list , currInd ,oracle);
}

MMElemIter & MMElemIter::inst(){
   static MMElemIter s;
   return s;
}

MMElemIter::MMElemIter()
  //:className("") //, superClassName("")
{
  classList=0;
  currClassInd=-1;

  enumList=0;
  currEnumInd=-1;
//
//  assocList=0;
//  currAssocInd=-1;
//
//  attrList=0;
//  currAttrInd=-1;
//
//  //subClassList=0;
//  //currSubClassInd=-1;
//
//  directAttrList=0;
//  currDirectAttrInd=-1;
//
//  directAssocList=0;
//  currDirectAssocInd=-1;
}


MMElemIter::~MMElemIter(){
  delete classList; classList=0;
  delete enumList; enumList=0;

  clearMap(  assocs );
  clearMap(  attributes );
  clearMap(  subClasses );
  clearMap(  directAttrs );
  clearMap(  directAssocs );

  std::map< string , std::pair<TList * , int > >::iterator
    it = enumElems.begin(),
    end = enumElems.end();
  for( ; it != end ; ++it ){
     TList * list = it->second.first;
     assert( list );
     for(int i=0; i < list->Count; i++ ){
       string * pListElem = (string*)(list->Items[i]);
       delete pListElem; list->Items[i]=0;
     }
     delete list; it->second.first = 0;
  }
}

bool MMElemIter::firstClass( string & resClassName ){
  delete classList;
  classList = RepositoryUser::getAllClassIDs();
  currClassInd = -1;
  return nextClass( resClassName );
}//

bool MMElemIter::nextClass ( string & resClassName ){
  long classID = getNextListElem( classList , currClassInd, ClassCheck() );
  if( classID != -1 ){
	resClassName = RepositoryUser::getClassName( classID );
	return true;
  }
  return false;
}//

bool MMElemIter::firstEnum( string & resEnumName ){
  delete enumList;
  enumList = RepositoryUser::getAllEnumIDs();
  currEnumInd = -1;
  return nextEnum( resEnumName );
}

bool MMElemIter::nextEnum ( string & resEnumName ){
  long enumID = getNextListElem( enumList , currEnumInd, EnumCheck() );
  if( enumID != -1 ){
	resEnumName = RepositoryUser::getTypeName( enumID );
	return true;
  }
  return false;
}

bool MMElemIter::firstAssoc( const  string & fromClassName ,
                             string & roleNameOut, string & invRoleNameOut,
			     string & toClassName)
{
  TList * assocList_loc = RepositoryUser::getAllAssocIDs( fromClassName );
  prepareMap( assocs , fromClassName , assocList_loc );
  return nextAssoc( fromClassName , roleNameOut , invRoleNameOut , toClassName );
}//

bool MMElemIter::nextAssoc ( const string & fromClassName ,  string & roleNameOut ,
			     string & invRoleNameOut, string & toClassName)
{
  long elemID = getNextElem( assocs, fromClassName, AssocCheck() );
  if( elemID != -1 ){
	  long invAssocID = RepositoryUser::getAssociationInverse( elemID );
	  long
		//assocSourceClassID = RepositoryUser::getAssociationSourceClassId(elemID),
		assocTargetClassID = RepositoryUser::getAssociationTargetClassId(elemID);
	  //fromClassName = RepositoryUser::getTypeName( assocSourceClassID );
	  roleNameOut = RepositoryUser::getTypeName( elemID );
	  invRoleNameOut = RepositoryUser::getTypeName( invAssocID );
	  toClassName = RepositoryUser::getTypeName( assocTargetClassID );
	  return true;
  }
  return false;
}//

bool MMElemIter::firstAssocDirect( const string & fromClassName ,
				   string & roleNameOut, string & invRoleNameOut,
				   string & toClassName)
{
  TList * directAssocList_loc = RepositoryUser::getDirectAssocIDs( fromClassName );
  prepareMap(directAssocs, fromClassName , directAssocList_loc );
  return nextAssocDirect( fromClassName , roleNameOut , invRoleNameOut , toClassName );
}//

bool MMElemIter::nextAssocDirect ( const string & fromClassName ,  string & roleNameOut ,
							 string & invRoleNameOut, string & toClassName)
{
  long elemID = getNextElem( directAssocs , fromClassName, AssocDirectCheck() );
  if( elemID != -1 ){
	  long invAssocID = RepositoryUser::getAssociationInverse( elemID );
	  long
		//assocSourceClassID = RepositoryUser::getAssociationSourceClassId(elemID),
		assocTargetClassID = RepositoryUser::getAssociationTargetClassId(elemID);
	  //fromClassName = RepositoryUser::getTypeName( assocSourceClassID );
	  roleNameOut = RepositoryUser::getTypeName( elemID );
	  invRoleNameOut = RepositoryUser::getTypeName( invAssocID );
	  toClassName = RepositoryUser::getTypeName( assocTargetClassID );
	  return true;
  }
  return false;
}//

bool MMElemIter::firstAttr ( const string & className_prm,  string & attrName ,
			     string & attrTypeName)
{
  TList * attrList_Loc = RepositoryUser::getAllAttributeIDs( className_prm );
  prepareMap(attributes, className_prm, attrList_Loc);
  return nextAttr( className_prm , attrName , attrTypeName );
}//

bool MMElemIter::nextAttr  ( const string & className_prm, string & attrName,
							 string & attrTypeName )
{
  long elemID = getNextElem( attributes, className_prm , AttrCheck( className_prm ) );
  if( elemID != -1 ){
	  //className_prm = className;
	  attrName = RepositoryUser::getTypeName( elemID );
	  attrTypeName = RepositoryUser::getAttrTypeName( elemID );
	  return true;
  }
  return false;
}//

bool MMElemIter::firstAttrDirect ( const string & className_prm,  string & attrName ,
							 string & attrTypeName)
{
  TList * directAttrList_loc = RepositoryUser::getDirectAttributeIDs( className_prm );
  prepareMap(directAttrs, className_prm , directAttrList_loc);
  return nextAttrDirect( className_prm , attrName , attrTypeName );
}//

bool MMElemIter::nextAttrDirect  ( const string & className_prm, string & attrName,
							 string & attrTypeName )
{
  long elemID = getNextElem( directAttrs , className_prm, AttrDirectCheck(className_prm) );
  if( elemID != -1 ){
	  //className_prm = className;
	  attrName = RepositoryUser::getTypeName( elemID );
	  attrTypeName = RepositoryUser::getAttrTypeName( elemID );
	  return true;
  }
  return false;
}//

bool MMElemIter::firstSubClass( const string & superClassName_prm , string & subClassName )
{
  TList * subClList = RepositoryUser::getSubClassesIDs( superClassName_prm );
  prepareMap( subClasses , superClassName_prm , subClList );
  return nextSubClass( superClassName_prm,  subClassName );
}//

bool MMElemIter::nextSubClass ( const string & superClassName_prm , string & subClassName)
{
  long elemID = getNextElem(subClasses, superClassName_prm, SubClassCheck() );
  if( elemID != -1 ){
	  subClassName = RepositoryUser::getTypeName(elemID);
	  return true;
  }
  return false;
}//


bool MMElemIter::firstEnumElem( const  string & enumName , string & enumElemNameOut ){
  TList * enumElemsList = RepositoryUser::getAllEnumElems( enumName );
  prepareMap( enumElems , enumName , enumElemsList );
  return nextEnumElem( enumName , enumElemNameOut);
}

bool MMElemIter::nextEnumElem( const  string & enumName , string & enumElemNameOut ){
  std::map< string , std::pair < TList* , int > >::iterator it;
  if( ! listReady( enumElems , enumName , it ) ) return -1;

  const int & elemCount = it->second.first->Count;
  int & currInd  = it->second.second;
  TList * & list= it->second.first;

  currInd++;

  for( ; currInd < elemCount ; currInd++ ){
    string enumElemNameOut_loc = *((string *)(list->Items[currInd]));
    if( RepositoryUser::enumHasElem( it->first , enumElemNameOut_loc ) ){
      enumElemNameOut = enumElemNameOut_loc;
      return true;
    }

  }
  return false;
}

bool ExistsClass( const string & className ){
  return RepositoryUser::existsClass( className );
}

bool ExistsEnum ( const string & enumName ){
  return RepositoryUser::existsEnum( enumName );
}

bool ExistsEnumElem(const string & enumName, const string & enumElemName){
  return RepositoryUser::existsEnum( enumName ) &&
         RepositoryUser::enumHasElem(enumName, enumElemName);
}

bool ExistsAttr( const string & className , const string & attrName , const string & typeName ){
  return RepositoryUser::existsAttribute( className, attrName, typeName );
}

bool ExistsAssoc( const string & classNameFrom , const string & roleName , const string & classNameTo){
   long clID = RepositoryUser::getClassIdByName( classNameFrom );
   if( ! clID ) return false;
   return RepositoryUser::getAssociationIdByName(clID, roleName.c_str());
}

bool ExistsCompos( const string & classNameFrom , const string & roleName , const string & classNameTo ){
   return RepositoryUser::existsComposition(classNameFrom , roleName );
}

bool ExistsRel( const string & subClassName , const string & superClassName){
   return RepositoryUser::isParent( superClassName, subClassName);
}

/*
jaunas operacijas getNext ralizacijas piezimes
fakti
principa klase var but iznicinata taja bridi kad kads cits apstaiga sis klases objektus

piem
		first x : A
		deleteclass A
		next x  //pec idejas janostajas uz null

apaksklases

B <-- D
|<-- D1 <--- D2
Ir domats ka no klases B manto klases D un D1

atkal
        first x : B
        deleteRel B.subclassOf.D //pec idejas pointerim x ir japarlec D klases objektus

kas notiek veicot addRel B.subclassOf.B2

        first x : B
        addRel B.subclassOf.B2 {

        }//
         //pec idejas ir jaierauga B2 klases objektus.


risinajumi :

1) Minimalistiskais risinajums
        darbibas sakuma sanemam visu klases B apaksklasu sarakstu
        un apstaigajam sis apaksklases neuztraucoties par to kas notiek izsaucot deleterel , addRel
        Ja tiek izsaukts deleteClass tad iznicinatas klases objekus mes tomer ignorejam.
        deleteClass semantika vai nu izmetam tikai tadu klasi,
          kurai nav neviena objekta
		  vai ari atlaujam mest ara  klasi kurai var but aari vairaki objekti,
          bet saja gadijuma pirms izsaukt ect_data_api.h::deleteClass patstavigi izmetam sis klases objektus

2) Ne tik minimalistiks risinajums
        sekojam lidzi izmainam metamodeli:

        IZMAKSAS ???
        NEPIECIESAMIBA ??? Observer MVC ??
        Jaseko lidzi sekojosiem notikumiem :

           addRel subclassOf ,
           deleteRel subclassOf,



*/
