//---------------------------------------------------------------------------

#ifndef L0_VarH
#define L0_VarH
//---------------------------------------------------------------------------

#include <vcl.h>
#include <cassert>

#include <string>
#include <vector>
#include <map>
#include <set>

using std::string;
using std::wstring;
using std::map;
using std::vector;
//---------------------------------------------------------------------------

extern const string nullPointerException;
extern const string unSupportedOperation;
extern const string classDoesNotExist;
extern const string assignmentFailed;

extern const int badObjID;
extern const int badInd;
extern const int badObjectTypeID;
extern const int badLinkTypeID;


void startSession();
void endSession();
long currentSessionID();

//var dinamiski mainit tipu proti viena bridi var but tiesa reference uz klases instancem
// otraja var but reference uz klases instancem caur asociaciju
class L0_Var_2_Exception{
public:
  L0_Var_2_Exception(const string & msg_prm):msg( msg_prm){}
  const string msg;
};



class LinkedPartnersIDListS{
  public:

  class MyLinkedPartnersList{
    public:
      vector<long> * ids;
      vector<bool> * skipId;
      void addPartner(long newPartnerId);
      void clear();
      long getVectorElemIndex(long vectorElem);
      void populateList(long assocID , long startObjID);
      MyLinkedPartnersList();
      ~MyLinkedPartnersList();
  };



  static LinkedPartnersIDListS & instance();
  ~LinkedPartnersIDListS();

  //vector<long> * getPartners1(long linkTypeID , long startObjectID);

  MyLinkedPartnersList * getPartners_2(long linkTypeID , long startObjectID);

  bool createLink1(long linkTypeID , long startObjectID , long newPartnerID );
  bool createLinkAfter(long linkTypeID , long startObjectID , long newPartnerID, long afterPartnerID );

  //bool existsRecordWhereLinkTypeID(long linkTypeID , long startObjectID);  //nav vajadziga
  // neefektivi
  //long getPartnerIDByIndex( long linkTypeInd , long startObjectID , long partnerIndex );
  //-1 ja <linkTypeInd , startObjectID> neatrodas tabula
  //long getPartnerCount(long linkTypeInd , long startObjectID);
  //
  string print();

private:
                     //linkTypeID ->objID1-> <o1,o2,o3>
                     //             ->objID2-><o1,o2,o3,04,05>
  //tabula 4 aiz atslegas <linkTypeId , objectId1> glabajas visu saistito
  //objectID2 saraksts fikseta seciba (jaunus Idus liek klat beigas , bet ara NEKAD neko nemet )


  void operator=(LinkedPartnersIDListS&); //not implemented
  LinkedPartnersIDListS(const LinkedPartnersIDListS&);

  //map<long , map<long , vector<long>* > * > linkedPartners;
  //linkTypeID , objID1 <linkedObjId vector> , sessionId when vector was retrieved
  //map<long , map<long , std::pair< vector<long>* , long > > * > linkedPartners1;



  //map<long , map<long , std::pair< std::pair< vector<long>* , vector<bool> * > , long > > * > linkedPartners2;
  map<long , map<long , std::pair< MyLinkedPartnersList * , long > > * > linkedPartners2;

  LinkedPartnersIDListS();

  void initPartnersIdListS();

  static void populatePartnerList(vector<long> * partnersList, long linkTypeId,
                                                           long startObjectId);

  vector<long> * getPartners(long linkTypeID , long startObjectID);
  //atgriez newPartnerId indeksu
  long addPartner(long linkTypeID , long startObjectID , long newPartnerID );
  bool putRecord( long linkTypeID , long startObjectID);
  void addAssocID(long assocID);
  bool existsRecord(long linkTypeID , long startObjectID);
};//class LinkedPartnersIDListS{

class L0_Var_2{

  public:  enum L0_VarKind{ UnInit, DirRef, RefByRel };
  private:
  class L0_Var_2_State{
      L0_Var_2_State(const L0_Var_2_State & rhs ); //not implemented to prevent copies
      L0_Var_2_State & operator=(const L0_Var_2_State & rhs);
    public:
     //const long classIDInDecl;
     const string classNameInDecl;
     //L0_Var_2_State(long classIDInDecl_prm):classIDInDecl(classIDInDecl_prm){}
     L0_Var_2_State(const string & classNameInDecl_prm):classNameInDecl(classNameInDecl_prm){}
     virtual ~L0_Var_2_State(){};

     virtual long getCurrObjID(){ assert( !"UnsupportedOperation" ); return badObjID; }
     virtual bool setFirstToRoot(const string & className){assert(!"UnsupportedOperation"); return false;}
     virtual bool setFirstFrom(const L0_Var_2 & startObj , const string & assocName){ assert(!"UnsupportedOperation"); return false;}
     virtual bool setFirstFrom(long startObjID , const string & assocName){ assert(!"UnsupportedOperation"); return false;}
     virtual void setNull(){}
     virtual bool isNull(){return true;}
     virtual bool moveNext(){ return false;}
     virtual void assign(const L0_Var_2 & rhs){}
     virtual void addObj( long newObjID , long newObjClassID ){assert(!"UnsupportedOperation" );}
     virtual bool pointsToBadObj(){
       //assert( !"UnsupportedOperation" );
       return true;
     }//
     virtual long getRawObjID() const{ return badObjID;}
  };

  class ReferenceByRelation : public L0_Var_2_State{
      long currObjInd;
      //const std::vector<long> * currPartnersList;   //points to shared memory do not delete
      LinkedPartnersIDListS::MyLinkedPartnersList * currPartnersList;   //points to shared memory do not delete
      long startObjID;
      long assocID;
      bool outOfBounds;
      //init( long startObjID , long assocID );
      long getFirstLegalObjIndex(//long startObjID ,
                                 //const std::vector<long> * partners ,
                                 long startIndex);

      void assignNullRhs( const L0_Var_2 & rhs );
      ReferenceByRelation & operator=(const ReferenceByRelation & rhs);//not implemented to prevent copies
    public:
//      ReferenceByRelation(long classIDInDecl_prm);
      ReferenceByRelation(const string & classNameInDecl_prm);
      ReferenceByRelation(const ReferenceByRelation & rhs );
      virtual long getCurrObjID();
      virtual bool setFirstFrom(const L0_Var_2 & startObj , const string & assocName);
      virtual bool setFirstFrom(long startObjID , const string & assocName);
      virtual void setNull();
      virtual bool isNull();
      virtual bool moveNext();
      virtual void assign(const L0_Var_2 & rhs);
      virtual bool pointsToBadObj();
      virtual long getRawObjID() const;
  };


  class DirectReferenceToRoot : public L0_Var_2_State{
       friend class L0_Var_2;
      //izpildot firstDirect sanemam pointeri uz vectoru ar apaksklasu ID`iem
      //saraksts satur ari base klasi, ja tada eksiste repo
      const std::vector<long> *  subClassesIDs;  //must be deleted
      long currSubClassIDInd;
      long currObjInd;
      bool outOfBounds;
      bool isVoidPointer;
      //init( long classID );
      static bool getFirstLegalObjIndex(
                             const vector<long> * const subClassesIDs,
                             long classIndexStartPos, long objStartPos,
                             long & resultingClassIndex , long & resultingObjIndex
                             );
      long getSubClassIndex(long subClassID)const;
      bool findDesiredIDPosition(long desiredID, long & currSubClassIDInd ,
                                 long & currObjInd)const;
      //void initSubClassesID(const string & className);
      DirectReferenceToRoot & operator=(const DirectReferenceToRoot & rhs);//not implemented to prevent copies
    public:
//      DirectReferenceToRoot(long classIDInDecl_prm);
      DirectReferenceToRoot(const string & classNameInDecl_prm, bool isVoidPointer);
      DirectReferenceToRoot(const DirectReferenceToRoot & rhs);
      ~DirectReferenceToRoot();
      virtual long getCurrObjID();
      virtual bool setFirstToRoot(const string & className);
      virtual void setNull();
      virtual bool isNull();
      virtual bool moveNext();
      virtual void assign(const L0_Var_2 & rhs);
      virtual void assignNullRhs(const L0_Var_2 & rhs);
      virtual void addObj( long newObjID , long newObjClassID);
      virtual bool pointsToBadObj();
      virtual long getRawObjID() const;
  };

  class UnInitialized : public L0_Var_2_State{
    UnInitialized & operator=(const UnInitialized & rhs);
    public:
      //UnInitialized(long classIDInDecl_prm):L0_Var_2_State(classIDInDecl_prm){}
      UnInitialized(const string & classNameInDecl_prm):L0_Var_2_State(classNameInDecl_prm){}
      UnInitialized(const UnInitialized & rhs ): L0_Var_2_State(rhs.classNameInDecl){}
      //virtual void assign(const L0_Var_2 & rhs); nemam no L0_Var_2_state
  };

  DirectReferenceToRoot directObjAddr;
  ReferenceByRelation   indirectObjAddr;
  UnInitialized         uninit;

  L0_Var_2_State * currentState;
  //const long classIDInDecl;
  const string classNameInDecl;
    //tas sesijas numurs, kura ar so objektu tika veiktas inicializejosas darbibas
    //konsstruesana , pieskirsaana, first
  long lastInitInSession;


  bool isVoidPointer;
  void changeState( L0_VarKind newKind );




  //bool findID( long desiredID , long & subClassInd , long & objInd) const;
  //long getFirstLegalObjIndex(long startObjID ,std::vector<long> * partners ,
  //                                                             long startIndex);
  //bool getFirstLegalObjIndex(const long * const subclassIndexes, long subclassCount,
  //                           long classIndexStartPos,long objStartPos,
  //                           long & resultingClassIndex , long & resultingObjIndex );

  //static long getElemIndex( std::vector<long> * cont , long elem);

  //masiva subClassesIndArr_ mekle elementu ar vertibu subClassIndex
  //un atdod si elementa indeksu(poziciju)
  //long getSubClassPos(long subClassIndex);
  friend class L0_Var_2::DirectReferenceToRoot;
  friend class L0_Var_2::ReferenceByRelation;

  long getAttrID_loc(const string & attrName)const;
  long getCurrObjIndex()const;
     //L0_Var_2(); nekur netika izmantots
     L0_Var_2 & operator=(const L0_Var_2 & rhs); //not implemented to prevent default copying

  public:
     L0_Var_2();
     L0_Var_2(const L0_Var_2 & rhs);
     explicit
     L0_Var_2(const string & className);

     bool operator==(const L0_Var_2 & rhs);
     bool operator!=(const L0_Var_2 & rhs);

     ~L0_Var_2();

     bool setFirstToRoot(const string & className );
     bool setFirstFrom( const L0_Var_2 & rhs , const string & assocName  );
     void setNull();
     void assign( const L0_Var_2 & rhs);
     //void assignNullRhs( const L0_Var_2 & rhs );

     bool isNull() const;
     bool isNotNull() const;


     bool moveNext();
     long getCurrentObjID() const;
     long getRawObjID() const;

     bool setAttributeValue(long attributeID , const string & newValue )const;
     bool setAttributeValue(const string & attrName , const string & newValue )const;

     bool setBoolAttributeValue(long attributeID , bool newValue )const;//is not used in code generation
     bool setLongAttributeValue(long attributeID , long newValue )const;//is not used in code generation
     bool setRealAttributeValue(long attributeID , double newValue )const;//is not used in code generation
     bool setStringAttributeValue(long attributeID , const string &  newValue )const;//is not used in code generation

     bool setBoolAttributeValue(const string &  attrName , bool newValue )const;
     bool setLongAttributeValue(const string &  attrName , long newValue )const;
     bool setRealAttributeValue(const string &  attrName , double newValue )const;
     bool setStringAttributeValue(const string &  attrName , const string &  newValue )const;

     string getAttributeValue(long attributeID) const;      //is not used in code generation
     string getAttributeValue(const string & attrName) const;

     bool   getBoolAttributeValue(long attributeID ) const; //is not used in code generation
     long   getLongAttributeValue(long attributeID )const;  //is not used in code generation
     double getRealAttributeValue(long attributeID )const;  //is not used in code generation
     string getStringAttributeValue(long attributeID)const; //is not used in code generation

     bool   getBoolAttributeValue(const string &  attrName ) const;//is not used in code generation
     long   getLongAttributeValue(const string &  attrName )const;//is not used in code generation
     double getRealAttributeValue(const string &  attrName )const;//is not used in code generation
     string getStringAttributeValue(const string &  attrName)const;//is not used in code generation

     bool   setEnumAttributeValue(const string & attrName , const string & enumLiteralName);
     string getEnumAttributeValue(const string & attrName );

     void addObj(const string & className );
     bool deleteObj();

     void addLink( const L0_Var_2 & rhs, const string & assocName)const;
     void addLinkAfter( const string & assocName ,
                        const L0_Var_2 & newPartner, const L0_Var_2 & afterPartner)const;
     void deleteLink(const L0_Var_2 & rhs, const string &  assocName)const;

     bool isTypeOf(const string & className )const;

     bool equals( const L0_Var_2 & rhs )const;
     bool notEquals( const L0_Var_2 & rhs )const;

     bool hasLink( const L0_Var_2 & rhs , const string & assocName)const;
     bool hasNoLink( const L0_Var_2 & rhs ,  const string & assocName)const;

     L0_VarKind getKind()  const;
     bool pointsToBadObj() const;
     string debugPrint();
};


void CreateClass( const string & className );
void DeleteClass( const string & className );
//faktiski zemakminetas funkcijas vards ir createIndependentAttribute standAlone
void CreateAttr( const string & attrName , char baseType); //baseType from ect_data_api.h
void CreateAttrConnectedToClass( const string & className , const string & attrName ,
                                 char baseType); //baseType from ect_data_api.h

void CreateAttrConnectedToClass( const string & className , const string & attrName ,
                                 const string &  baseTypeName);

//kada veida veidot attributus kuru tips ir enumeration ???
//void createEnumerationAttr(const string & attrName , const vector<const string> & enumElems); sk. CreateEnum
void DeleteAttr( const string & attrName );

void AddAttr( const string & attrName , const string & className);
void RemoveAttr( const string & attrName , const string & className);

void CreateAssociation( const string & subjectClassName, const string & subjectRoleName,
                        char subjectEndCardinality,
                        const string & objectClassName, const string & objectRoleName,
                        char objectEndCardinality,
                        bool fromIsOrdered, bool toIsOrdered );
void CreateComposition(const string & subjectClassName, const string & subjectRoleName,
                        char subjectEndCardinality,
                        const string & objectClassName, const string & objectRoleName,
                        char objectEndCardinality,
                        bool fromIsOrdered, bool toIsOrdered );
void DeleteAssociation(const string & subjectClassName, const string & assocName,
                       const string & objectRoleName);
void CreateGeneralization(const string & baseClassName , const string & derivedClassName);
void DeleteGeneralization(const string & baseClassName , const string &  derivedClassName);
void CreateEnum(const string & enumName , const string * enumLiterals, int enumLiteralCount );

void DeleteEnum(const string & enumName);//atkabina enum no klasem kur tas tiek izmantots un iznicina
void AddEnumElem(const string & enumElemName, const string & enumName);
void DeleteEnumElem(const string & enumElemName, const string & enumName);


bool ExistsClass   (const string & className);
bool ExistsEnum    (const string & enumName);
bool ExistsEnumElem(const string & enumName, const string & enumElemName);
bool ExistsAttr    (const string & className , const string & attrName , const string & typeName );
bool ExistsAssoc   (const string & classNameFrom , const string & roleName , const string & classNameTo);
bool ExistsCompos  (const string & classNameFrom , const string & roleName , const string & classNameTo );
bool ExistsRel     (const string & subClassName , const string & superClassName);



//tabula glabajam visas klases pie kuram lietotajs tiesa veida griezas(first, addObj) seansa laika,
//kas eksisteja repozitorija seansa laika  ( ari izmestas )
//katrai klasei aatbilst saraksts ar sis  klases objektu ID`iem
class L0_ObjectIDListS{

  void operator=(L0_ObjectIDListS&);          //all three not implemented to prevent copy
  L0_ObjectIDListS(const L0_ObjectIDListS&);
  L0_ObjectIDListS(L0_ObjectIDListS&);

  void initClassWithSubClasses(long classID );
  void initClassWithoutSubClasses(long ClassID );
  static void retrieveObjects(long classID , vector<long> * vec );
  vector<long> * getObjectsRaw(long classID);
  //<clID , [<obj1_Id, obj2_Id, obj3_Id> , sessionID ]>
  //classID, <classObjectsIDList, sessionIDWhenClassObjectsRetrievedFromRepo> >

  std::map<long , std::pair< vector<long> * , long > >classes;
  L0_ObjectIDListS();

public :

  static L0_ObjectIDListS & instance();
  //atgriez klases ar doto ID elementu skaitu , neieskaitot apaksklasu instances
  // katrai klasei aatbilsts vektors. elemCount ir si vektora size
  long elementCount (long classID); // const ;
  long getObjID( long classID , long objInd );
  //long addObjID(long classID , long newObjID); //atgriez jauna objekta indeksu
  long createObject(long classID);//atgriez jauna objektu ID
  //void addClassID( long classID );
  bool isCorrectIndex( long classID , long objInd); //vai ir vajadziga?
  const vector<long> * getObjects(long classID);

  ~L0_ObjectIDListS();
};//class L0_ObjectIDListS{











//
class Links{
 //Tabula 3 aiz atslegas < linkTypeID , objID1 , objID2 >
 //glabajas pazime links eksiste vai neeksiste

 void operator=(Links&); //not implemented
 Links(const Links&); //not implemented

 Links();
 void initLinks();


 typedef std::pair<long,long> pairOfLong;

 //assocID , set<ObjID1,ObjID2>

 std::map<long , std::set<pairOfLong> *  >   mapOfLinksSet;
 std::set<pairOfLong> * populateLinksSet(long linkTypeID);
public:

  static Links & instance();

  //bool addNewLink(long linkTypeID , long objID1, long objID2);
  //void addNewLink(long linkTypeID , long objID1, long objID2);  
  //bool deleteLink(long linkTypeID , long objID1, long objID2);

  bool existsLink(long linkTypeID , long objID1, long objID2) const;
  // existsLink_2 bez assertiem
  bool existsLink_2(long linkTypeID , long objId1 ,long objId2) const;

  string print();
  ~Links();
};


//L0_Var_2 getEventInstanceFromId(long id);



//ieviesam jaunas L0 komandas, ar kuru palidzibu vares parlasit MM elementus
//class MMElemIter{
//public :
//  bool firstClass( string & resClassName );
//  bool nextClass ( const string & currentClassName , string & resClassName );//atrod "nakamo"(vel neapmekleto) pec  dota
//
//  bool firstAssoc( const string & fromClassName , const string & toClassName ,
//                   string & resAssocName);
//  bool nextAssoc ( const string & fromClassName , const string & toClassName ,
//                   const string & currAssocName ,
//                   string & resAssocName);
//  bool firstAttr ( const string & className,  string & resAttrName );
//  bool nextAttr  ( const string & className, const string & currAttrName,
//                   string & resAttrName );
//
//  bool firstSubClass( const string & superClassName , string & resClassName );
//  bool nextSubClass ( const string & superClassName , const string & currSubClassName,
//                      string & resClassName );
//  //attrType translejam tiesa veidu uz if`u
//};

//ieviesam jaunas L0 komandas, ar kuru palidzibu vares parlasit MM elementus

class MMElemIter{

public :

  bool firstClass( string & resClassName );
  bool nextClass ( string & resClassName );

  bool firstEnum( string & resEnumName );
  bool nextEnum ( string & resEnumName );

  bool firstEnumElem( const  string & enumName , string & enumElemNameOut );
  bool nextEnumElem( const  string & enumName , string & enumElemNameOut );


  bool firstAssoc( const  string & fromClassName ,
				   string & roleNameOut,string & invRoleNameOut,
				   string & toClassName);

  bool firstAssocDirect( const string & fromClassName ,
						 string & roleNameOut,string & invRoleNameOut,
						 string & toClassName);

  bool nextAssoc ( const string & fromClassName ,
				   string & roleNameOut,string & invRoleNameOut,
				   string & toClassName);

  bool nextAssocDirect ( const string & fromClassName ,
						 string & roleNameOut,string & invRoleNameOut,
						 string & toClassName);

  bool firstAttr ( const string & className,  string & resAttrName ,
				   string & resAttrTypeName );
  bool firstAttrDirect ( const string & className,  string & resAttrName ,
						 string & resAttrTypeName );
  bool nextAttr  ( const string & className, string & attrName, string & attrTypeName );
  bool nextAttrDirect  ( const string & className, string & attrName,
						 string & attrTypeName );

  bool firstSubClass( const string & superClassName , string & firstSubClassName );
  bool nextSubClass ( const string & superClassName , string & subClassName );
  //attrType translejam tiesa veidu uz if`u ???

  static MMElemIter & inst();
  ~MMElemIter();

private:

  MMElemIter();

  TList * classList;
  int currClassInd;

  TList * enumList;
  int currEnumInd;


  //ClassName , attrList , currInd in attrList
  std::map< std::string , std::pair< TList * , int > > assocs;

  //@depr
  //TList * assocList;
  //int currAssocInd;

  //ClassName , attrList , currInd in attrList
  std::map< std::string , std::pair< TList * , int > > attributes;

  //@depr
  //string className;
  //TList * attrList;
  //int currAttrInd;

  //ClassName , subClassList , currInd in subClassList
  std::map< std::string , std::pair< TList * , int > > subClasses;

  //@depr
  //string superClassName;
  //TList * subClassList;
  //int currSubClassInd;


  //directClassName , directAttrList , currInd in directAttrList
  std::map< std::string , std::pair< TList * , int > > directAttrs;

  //@depr
  //string directClassName;
  //TList * directAttrList;
  //int currDirectAttrInd;

  //directClassName , directAssocList , currInd in directAssocList
  std::map< std::string , std::pair< TList * , int > > directAssocs;

  //@depr
  //TList * directAssocList;
  //int currDirectAssocInd;

  //enumName  currEnumNameInd
  //TList contains pointers to enumElemNames, string *
  std::map< std::string , std::pair< TList * , int > > enumElems;
};

//Mantosana metamodeli???
class RepositoryChangeListener{

  //hash_map butu atrak
  std::map< long , vector< long > > changedInstances;

  std::vector<long> deletedObjects;

  RepositoryChangeListener();
  void addChangedInstance( long objId );
  void addChangedInstance( long objId , long  thisObjClassId );
public :

  static RepositoryChangeListener & instance();

  void objectDeleted(long objId, long thisObjTypeId);// papildus varetu but classID , classInd
  void objectCreated(long objId);// papildus varetu but classID , classInd

  void linkDeleted(long linkTypeID , long objId1 , long objId2);
  void linkCreated(long linkTypeID , long objId1 , long objId2);

  //seansa laika bija pieprasijums uzstadit attributu vertibu
  //iespejams ka jaunuzstadita attributa evrtiba ir tada pati ka pirms uzstadisanas
  void attributeValueSet(long objId , long attrId, const WideString & attrVal );

  void getChangedInstances( vector<long> & result );
  const vector<long> & getDeletedObjects();  
  void setMonitoredClasses( vector< long > const & monitoredClasses );

  virtual ~RepositoryChangeListener();
};//class RepositoryChangeListener{



//---------------------------------------------------------------------------
#endif



/*
Viena no alternativam visuresosam setNull() izsaukumiem ir smago( neacimredzamo, gruti atklajamo )
kludu gadijuma pirms setNull() izsaukuma radit zinojumu ar pazinojumu par kludu
piem:
addLink( rhs , assocN ) ja assocN neeksiste radam( kaut kur ierakstam ) zinojumu par to ka ta neeksiste
un izsaucam setNull



Iespejamas kludas darba ar klasi L0_Var_2

constr( name )      -- name neeksiste rada pazinojumu ok
firstToRoot( name ) -- name neeksiste ok, rada pazinojumu, setNull()
                    -- name eksiste, bet nav apaksklase no konstruktora parametra L0 programetaja kluda,
                       beidz darbu

setFirstFrom( fromV , assocN )
                         -- fromV ir null setNull
                         -- assocN neeksiste rada pazinojumu un setNull


addObj ( clName )   -- clName neeksiste -- ok, rada pazinojumu, setNull()
addObj ( clName )   -- clName nav apaksklase no klases constr`a --
                       L0 programetaja kluda , (faktiski netiess pieprasijums mainit savu tipu,)
                       beidz darbu
deleteObj           -- ja ir Null nekas netiek iznicinats
addLink ( rhs , assocN ) ja rhs vai this  ir Null , saite netiek veidota
                         ja assocN neeksiste ,
                         rada pazinojumu,
                         saite netiek veidota

deleteLink(rhs,assocN )   ja rhs vai this  ir Null , saite netiek iznicinata
                         ja assocN neeksiste,
                         rada zinojumu ka nav assoc
                         saite netiek iznicinata,

assign ( rhs )      -- ja tipi nav savietojami , vai ari ja this vertibu kopa nesatur lhs->currObjID
                       ok,
                       radaPazinojumu,
                       setNull()

/* TODO : implement L0 programmer error handling in (get/set)AttributeValue */
/*
getAttributeValue ( attrN )       ja this ir null tad  L0  programmetaja kluda , beidz darbu
setAttributeValue ( attrN , val ) ja attrN neeksiste,
                                  rada pazinojumu,
                                  neko nedara

getAttributeValue ( attrN )       ja attrN neeksiste tad  L0  programmetaja kluda, beidz darbu
setAttributeValue ( attrN , val ) ja attrN neeksiste, tad  L0  programmetaja kluda,
                                  rada pazinojumu ,
                                  neko nedara

hasLink(rhs , assocN )  -- ja rhs vai this ir null , tad atgriez false
                           ja assocN neeksiste, tad rada zinojumu, atgriez false
moveNext()   -- ja this ir null neko nedara

*/
