//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <strRoutine.h>

#include "Logger.h"
#include <iomanip.h>

//#include "..\L0TranslatorCurr\strRoutine.h"

//---------------------------------------------------------------------------
Logger::Logger(){
  log.open( "L0_trace.txt" );
  if ( ! log ){
    AnsiString msg = "Can not open file \"";
    msg+=GetCurrentDir()+"\\L0_trace.txt";
    msg+="\".";
	ShowMessage( msg );
  }
  indent=0;
}//

Logger::~Logger(){
  log.flush();
}//

Logger & Logger::inst(){
  static Logger inst;
  return inst;
}//

void Logger::incrIndent(){ indent++; }

void Logger::decrIndent(){ indent--; }

void Logger::wrtLineNum( long lineNum ){
  for(long i =0 ; i < indent ; i++ ) log<< "   ";
  //log << lineNum << " : "<<endl;
  log << setw(4) << (lineNum + 1) << /*setw(0) is done by default<<*/ " : "<<flush;
}//

void Logger::wrtLine( const string & line ){
  //for(long i =0 ; i < indent ; i ++ ) log<< "   ";
  log << line << endl;
}//

void Logger::wrtLineWithPref( const string & line_prm ){
  for(long i=0 ; i < indent ; i++ ) log<< "   ";
  //original log << line_prm << endl;
  log << line_prm;
  //log << endl;
}//

void Logger::wrtPref(){
  for(long i =0 ; i < indent ; i++ ) log<< "   "<<flush;
}//

void Logger::newLine(){ log << endl; }//
void Logger::wrtBool( bool b   )           {log << boolalpha  << b <<flush;}//
void Logger::wrtReal( double d )           {log <<d   <<flush;                 }//
void Logger::wrtInt ( long l   )           {log <<l   <<flush;                 }//
void Logger::wrtStr ( const string & line ){log <<"\""<<StrRoutine::replaceEscapeSequences(line)<<"\""<<flush;  }//
void Logger::wrt(const string & line ){  log <<line<<flush; }//


#pragma package(smart_init)

