//------------------------------------------------------------------------------
#ifndef LoggerH
#define LoggerH
//------------------------------------------------------------------------------

#include <fstream.h>
#include <string.h>

class Logger{
  Logger();
  Logger( const Logger &);  Logger & operator=( const Logger &);
  ofstream log;
  long indent;
public:
  static Logger & inst();
  ~Logger();  
  void incrIndent();
  void decrIndent();
  void wrtLineNum( long lineNum );
  void wrtLineWithPref( const string & line );
  void wrtPref();

  void newLine();
  void wrtLine( const string & line );

  void wrtBool( bool b   );
  void wrtReal( double d );
  void wrtInt ( long l   );
  void wrtStr ( const string & line );
  void wrtEnum ( const string & line ){ wrt(line);}
  void wrt(const string & line );    
};
#endif
 