//---------------------------------------------------------------------------

#pragma hdrstop

#include "RepositoryUser.h"

#include <assert.h>

//#include <c:\kp\ect\ect_data_api.h>
#include <mii_rep_api.h>
#include "L0_Var.h" //badLinkTypeId
//#include "../L0TranslatorCurr/StrRoutine.h"
#include "strRoutine.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)


//
//
//
//
//
//
//
//   class RepositoryUser
//
//
//

long RepositoryUser::getAttributeIdByName(long classID, const WideString & name ){
   return GetPropertyTypeIdByName( classID, name );
}//

long RepositoryUser::getAssociationIdByName( long classID, const WideString & assocName ){
   return GetLinkTypeIdByName(classID, assocName);
}//

long RepositoryUser::getAssociationInverse( long assocID ){
  return GetInverseLinkTypeId( assocID );
}//


//int GetLinkTypeAttributes1(long LinkTypeId,
//                   long &SideObjTypeId1, char &Cardinality1,
//                   long &SideObjTypeId2, char &Cardinality2,
//                   long &InverseLinkTypeId); // 0 - error

long RepositoryUser::getAssociationSourceClassId( long assocID ){
  long sourceClassId=-1;
  bool resultOk = 0;
  {
    long longTemp_loc_xxx=0; char charTemp_loc_xxx=0;
    resultOk = GetLinkTypeAttributes1( assocID, sourceClassId,
                                       charTemp_loc_xxx,longTemp_loc_xxx,
                                       charTemp_loc_xxx,longTemp_loc_xxx);
  }
  if( resultOk ){
    return sourceClassId;
  }
  return 0;
}//

long RepositoryUser::getAssociationTargetClassId( long assocID ){
  long targetClassId=-1;
  bool resultOk = 0;
  {
    long longTemp_loc_xxx=0; char charTemp_loc_xxx=0;
    resultOk = GetLinkTypeAttributes1( assocID,
                                       longTemp_loc_xxx,charTemp_loc_xxx,
                                       targetClassId,
                                       charTemp_loc_xxx,longTemp_loc_xxx);
  }
  if( resultOk ){
    return targetClassId;
  }
  return 0;
}//

//RepositoryUser::propertyBaseType RepositoryUser::getAttributeType(long attrID){
baseType RepositoryUser::getAttributeType(long attrID){
  char ptype = GetPropertyBaseType(attrID);
  switch ( ptype ){
    case BaseType_STRING        : return Str;
	case BaseType_INTEGER       : return MyInt;
    case BaseType_FLOAT         : return Real;
    case BaseType_BOOLEAN       : return Bool;
    case BaseType_ENUMERATION   : return Enum;
    default:
      return Absent;
  }//switch
}//

baseType RepositoryUser::getAttributeType(const string & className , const string & attrName  ){
  long clID = GetObjectTypeIdByName( className.c_str() );
  if(!clID) return Absent;
  long attrID = GetPropertyTypeIdByName(clID , attrName.c_str() );
  return getAttributeType( attrID );
}//


bool RepositoryUser::existsAttribute(const string & clName , const string & attrName){
  long clID = GetObjectTypeIdByName( clName.c_str() );
  if(!clID) return false;
  long attrID = GetPropertyTypeIdByName(clID , attrName.c_str() );
  return attrID;
}

bool RepositoryUser::existsAttribute(const string & clName , const string & attrName , const string & attrTypeName ){
  long clID = GetObjectTypeIdByName( clName.c_str() );
  if(!clID) return false;
  long attrID = GetPropertyTypeIdByName(clID , attrName.c_str() );
  if( ! attrID ) return false;
  if( getAttributeType( attrID ) != Enum ){
    baseType b = getAttributeType( attrID );
    char attrTypeCode = getEBMTypeCodeByName( attrTypeName );
    return equalsBaseTypeMyBaseTypeEBM( b , attrTypeCode );
  }else{
    AnsiString s = GetTypeName(attrID);
    string name_loc = s.c_str();
    return (name_loc == attrTypeName); 
  }
}

bool RepositoryUser::existsEnum(const string & enumName){
   long propId = GetPropertyTypeIdByName( 0 , enumName.c_str() );
   if( ! propId ) return 0;
   bool isEnum = GetPropertyBaseType( propId ) == BaseType_ENUMERATION ;
   return isEnum;
}//

bool RepositoryUser::existsClass(const string & className){
   return GetObjectTypeIdByName( className.c_str() );
}//

bool RepositoryUser::existsComposition(const string & className, const string & roleName){
   long clID = GetObjectTypeIdByName(className.c_str());
   long assocID = GetLinkTypeIdByName( clID , roleName.c_str() );
   if( ! assocID ) return false;

   char role1=0, role2=0;
   {
	 long tl=0; char tc=0;
	 int ok = GetLinkTypeAttributes2(assocID,
			  tl, tc, role1,
			  tl, tc, role2,
			  tl); // 0 - error
     if( ! ok ) return false;
   }
   return role1 == Role_Aggregate;
}//


bool RepositoryUser::objectExists(long objectID){
  return ObjectExists(objectID);
}//

bool RepositoryUser::linkExists(long LinkTypeID, long objectID1,long objectID2 ){
  return AlreadyConnected( LinkTypeID , objectID1, objectID2 );
}//

long RepositoryUser::getSideObjTypeId1(long LinkTypeID){
  long sideObjTypeId1=-1;
  int error = 0;


  {
    long longTemp_loc_xxx=0; char charTemp_loc_xxx=0;
    error = GetLinkTypeAttributes1(LinkTypeID , sideObjTypeId1,
                                      charTemp_loc_xxx , longTemp_loc_xxx,
                                      charTemp_loc_xxx , longTemp_loc_xxx);
  }

  if ( error != 0 ) {
    return sideObjTypeId1;
  }else{
    assert(false);
    return badLinkTypeID;
  }
}//

long RepositoryUser::getClassIdByName( const wstring & name ){
   return GetObjectTypeIdByName( name.c_str() );
}//

long RepositoryUser::getClassIdByName( const string & name ){
   return GetObjectTypeIdByName( name.c_str() );
}//



bool RepositoryUser::classExists( long classID ){
   bool exists = ! GetTypeName(classID).IsEmpty() ;
   return exists;
}//

bool RepositoryUser::assocExists( long assocID ){
   bool exists = ! GetTypeName(assocID).IsEmpty() ;
   return exists;
}//

bool RepositoryUser::assocStartsFrom( long assocID , long classID ){
  if( ! classExists(classID) || ! assocExists( assocID ) )return false;
  TList * assocs = GetLinkTypeIdList( classID );
  bool res=false;
  if(assocs){
    for(int i=0; i < assocs->Count ; i++){
      long currAssocId = (long)assocs->Items[i];
      if( currAssocId == assocID ){
        res=true; break;
      }
    }
  }
  delete assocs; assocs=0;
  return res;
}//
//result nav null proti sanemam jau uzkonstruetu vectoru
void RepositoryUser::populateAllSubClassID(long baseClassID, vector<long> * result)
{
  TList * baseExtensions = GetExtensionIdList(baseClassID);
  if (baseExtensions){
    for (long i=0; i < baseExtensions->Count ; i++   ){
       long currClassID=(long) (baseExtensions->Items[i]);
       populateAllSubClassID(currClassID,result);
    }//for
  }
  result->push_back(baseClassID);
  delete baseExtensions; baseExtensions=0;
}

TList * RepositoryUser::getSubClassesIDs( const string & name){
  long clID = getClassIdByName( name );
  return GetExtensionIdList(clID);
}

//atgriez noradi uz vector ar visu className apaksklasu
//(ieskaitot ari tos kuri atrodas zemak neka 1 limeni) identifikatoriem
//
//saraksta pedejais elements ir id(className)
//
//ja  baseClass neeksiste repozitoriaj atgriez null

vector<long> * RepositoryUser::getAllSubClassesID(const string & className){
  long baseClassID=RepositoryUser::getClassIdByName(className);
  return RepositoryUser::getAllSubClassesID(  baseClassID );
}//

//TList * RepositoryUser::getAllSubClassesID_2(const string & className){
//  long baseClassID=RepositoryUser::getClassIdByName(className);
//  vector< long > * vec = RepositoryUser::getAllSubClassesID(  baseClassID );
//  assert( vec != 0 );
//
//  TList * res = new TList();
//  for( unsigned long i=0 ; i + 1 < vec->size() ; i++ ){//ignore last element
//    long currElem = vec->at(i);
//    res->Add( (void*)currElem );
//  }
//  return res;
//}//


vector<long> * RepositoryUser::getAllSubClassesID(long classID){
  vector<long> * result = new vector<long>();
  populateAllSubClassID( classID , result );
  return result;
}//

bool RepositoryUser::isParent(const string &  parentName , const string & childName ){
   if( parentName == childName ) return false;
   bool bothExists= RepositoryUser::existsClass(parentName) &&
                    RepositoryUser::existsClass(childName);
   if (!bothExists) return false;
   long childID  = RepositoryUser::getClassIdByName(childName),
        parentID = RepositoryUser::getClassIdByName(parentName);
   return isSuperClass(parentID ,childID );
}//

bool RepositoryUser::isSuperClass(long  superClassID , long subClassID ){
  vector<long> * subclassIds = RepositoryUser::getAllSubClassesID(superClassID);
    if (!subclassIds) return false;
    bool isParent = false;
    for(unsigned int i=0; i<subclassIds->size();i++){
      long curSubClassID_loc = subclassIds->at(i);
      if ( curSubClassID_loc == subClassID ){
       isParent = true;
       break;
     }
    }//for
  delete subclassIds; subclassIds=0;
  return isParent;
}//

long RepositoryUser::getObjectNum(long objTypeId){
   return GetObjectNum(objTypeId);
}//

long RepositoryUser::getObjectIdByIndex(long objTypeId , int index){
   return GetObjectIdByIndex(objTypeId,index);
}//

void RepositoryUser::getAllLinkTypes(vector<long> * result){
   if (result){
      TList * allLinkTypes=GetLinkTypeIdList(0);
      if (allLinkTypes){
        long linkTypesCount=allLinkTypes->Count;
        result->clear();
        result->reserve(linkTypesCount);
        for(long i=0; i< linkTypesCount; i++){
           result->push_back( (long)(allLinkTypes->Items[i]));
        }
      }
      delete allLinkTypes; allLinkTypes=0;
   }
}//

TList * RepositoryUser::getAllAssocIDs(const string & className){
  long classID = getClassIdByName( className );
  return GetLinkTypeIdList(classID);
}//

TList * RepositoryUser::getDirectAssocIDs(const string & className){
  long clID = GetObjectTypeIdByName( className.c_str() );
  long supClID = GetExtendsId( clID );

  TList * cl_linkIDs = GetLinkTypeIdList( clID );
  assert( cl_linkIDs );

  if( supClID == 0 ) return cl_linkIDs;//nav virsklases

  TList * supCl_linkIDs = GetLinkTypeIdList( supClID );
  assert( supCl_linkIDs );

  TList * res = new TList();
  for(int i=0; i < cl_linkIDs->Count ; i++ ){
     long currItem = long(cl_linkIDs->Items[i]);
     if( supCl_linkIDs->IndexOf( (void*) currItem ) == -1 )
       res->Add( (void*) currItem );
  }
  delete cl_linkIDs; cl_linkIDs=0;
  delete supCl_linkIDs; supCl_linkIDs=0;
  return res;
}

TList * RepositoryUser::getAllAttributeIDs(const string & className){
  long classID = getClassIdByName( className );
  return GetPropertyTypeIdList(classID);
}//

TList * RepositoryUser::getAllEnumIDs(){
  //TList * allAttrs = GetPropertyTypeIdList( 0 );// GetPropertyTypeIdList( 0 ) atgriez tuksu sarakstu
  //TList * res = new TList();

  set<long> enumIDs;
  TList * classes = GetObjectTypeIdList();
  for(int i=0; i < classes->Count ; i++ ){
    long currClassId = (long) classes->Items[i];
    TList * currClassAttrs = GetPropertyTypeIdList(currClassId);
    for(int j=0; j < currClassAttrs->Count; j++){
      long currAttrId = (long) currClassAttrs->Items[j];
      char baseTypeCode = GetPropertyBaseType( currAttrId );
      bool isEnum = baseTypeCode == BaseType_ENUMERATION;
      if( isEnum ) enumIDs.insert( currAttrId );
    }
    delete currClassAttrs;
  }
  delete classes;

  TList * res = new TList();
  set<long>::iterator it = enumIDs.begin(), end = enumIDs.end();
  for( ; it != end; ++it){
    res->Add( (void*) *it );
  }
  return res;
}

TList * RepositoryUser::getAllEnumElems(const string & enumName){
   TList * res = new TList();
   long enumID = GetPropertyTypeIdByName( 0 , enumName.c_str() );
   if( enumID == 0 ) return res;
   for(int i=0; i < GetEnumNameNum( enumID ); i++){
     WideString currEnumName = GetEnumNameByIndex( enumID , i );
     AnsiString s(currEnumName);
     string * currStr = new string( s.c_str() );
     res->Add((void*)currStr);
   }
   return res;
}

TList * RepositoryUser::getDirectAttributeIDs(const string & className){
  long clID = GetObjectTypeIdByName( className.c_str() );
  long supClID = GetExtendsId( clID );

  TList * cl_attrIDs = GetPropertyTypeIdList( clID );
  assert( cl_attrIDs );

  if( supClID == 0 ) return cl_attrIDs;

  TList * supCl_attrIDs = GetPropertyTypeIdList( supClID );
  assert( supCl_attrIDs );

  TList * res = new TList();
  for(int i=0; i < cl_attrIDs->Count ; i++ ){
     long currItem = long(cl_attrIDs->Items[i]);
     if( supCl_attrIDs->IndexOf( (void*) currItem ) == -1 )
       res->Add( (void*) currItem );
  }
  delete cl_attrIDs; cl_attrIDs=0;
  delete supCl_attrIDs; supCl_attrIDs=0;
  return res;
}

string RepositoryUser::getAttrTypeName(long attrID){
    baseType bt = getAttributeType( attrID );
    switch ( bt ){
       case MyInt : return "Integer";
       case Real: return "Real";
       case Bool: return "Boolean";
       case Str: return "String";
       case Enum: return "Enum";
    }
    return "";
}//

char RepositoryUser::getEBMTypeCodeByName(const string & typeName){
  char typeCode = BaseType_ENUMERATION;
  if( typeName == "Integer" ) typeCode = BaseType_INTEGER;
  else if( typeName == "Real" ) typeCode = BaseType_FLOAT;
  else if( typeName == "Boolean" ) typeCode = BaseType_BOOLEAN;
  else if( typeName == "String" ) typeCode = BaseType_STRING;
  return typeCode;
}

void RepositoryUser::getAllClasses(vector<long> & result){
  TList * allClasses=GetObjectTypeIdList();
  if (allClasses){
    long classesCount=allClasses->Count;
    result.clear();
    result.reserve(classesCount);
    for(long i=0; i< classesCount; i++){
      result.push_back( (long)( allClasses->Items[i]) );
    }
  }
  delete allClasses; allClasses=0;
}//

vector<long> * RepositoryUser::getAllClassesIDs(){
  vector<long> * res = new vector<long>();
  getAllClasses( * res );
  return res;
}


TList * RepositoryUser::getAllClassIDs(){
  return GetObjectTypeIdList();
}



bool RepositoryUser::deleteObject(long objectID){
   long objTypeId = RepositoryUser::getObjectTypeId( objectID );
   int deleted=DeleteObjectHard(objectID);
           //AnsiString msg = "Object deletion :";
           //msg+=IntToStr(objectID).c_str();
           //msg+=" .";
           //ShowMessage(msg);
   assert(deleted);

   if( deleted ){
     RepositoryChangeListener::instance().objectDeleted( objectID , objTypeId );
   }

   return deleted;
}//




long RepositoryUser::createObject_zzz( long classID ){
   //long newObjID=CreateObject(classID);
   //if (!newObjID) return badObjID;
   //
   //RepositoryChangeListener::instance().objectCreated( newObjID );
   //
   //long newInd=
   // L0_ObjectIDListS::instance().addObjID( classID , newObjID );
   //assert(newInd>=0);
   //return newObjID;


   long newObjID=L0_ObjectIDListS::instance().createObject( classID );
   if (newObjID==badObjID) return badObjID;
   RepositoryChangeListener::instance().objectCreated( newObjID );
   return newObjID;
}//

long RepositoryUser::createObjectRaw( long classID ){
  return CreateObject(classID);
}//

long RepositoryUser::createLinkRaw(long linkTypeId, long objId1 , long objId2){
  int ir=CreateLink(linkTypeId,objId1,objId2);
  if( ir ){
   RepositoryChangeListener::instance().linkCreated(linkTypeId, objId1,objId2);
  }
  return ir;
}

long RepositoryUser::createLinkAfterRaw(long linkTypeId, long objId1 , long objId2, long afterPartnerID){
  assert( ! "Not implemented" );

  /* TODO : Implement RepoUser::createLinkAfterRaw */
}


void RepositoryUser::createLink(long linkTypeId, long objId1 , long objId2){
  bool created = LinkedPartnersIDListS::instance().createLink1( linkTypeId, objId1 , objId2 );
  if ( created ){
    RepositoryChangeListener::instance().linkCreated( linkTypeId ,
                                                        objId1 , objId2 );
  }else{
     ShowMessage ( "Can not create link.");
  }
  assert( created );
}//

void RepositoryUser::createLinkAfter(long linkTypeID, long objID1,
                                     long objID2, long afterPartnerID)
{
  bool created = LinkedPartnersIDListS::instance().
                  createLinkAfter( linkTypeID, objID1 , objID2, afterPartnerID );
  if ( created ){
    RepositoryChangeListener::instance().linkCreated( linkTypeID ,
                                                        objID1 , objID2 );
  }else{
     ShowMessage ( "Can not create link.");
  }
  assert( created );
}



bool RepositoryUser::createLink_2(long linkTypeId, long objId1 , long objId2){
  bool created = LinkedPartnersIDListS::instance().createLink1( linkTypeId, objId1 , objId2 );
  if ( created ){
    RepositoryChangeListener::instance().linkCreated( linkTypeId ,
                                                        objId1 , objId2 );
  }
  return created;
}//

/*
bool RepositoryUser::createLinkZZZ(long linkTypeId, long objId1 , long objId2){
  bool pre  = linkTypeId != 0 && objId1 != 0 && objId2 !=0 ;
  assert(pre);
  int created=CreateLink(linkTypeId,objId1,objId2);
  if ( created==0 ) ShowMessage ( "Can not create link.");
  assert(created);

  //ShowLink(linkTypeId,objId1,objId2);

  if ( created ){
    RepositoryChangeListener::instance().linkCreated( linkTypeId ,
                                                        objId1 , objId2 );
  }

  //long invLinkTypeID= GetInverseLinkTypeId(linkTypeId);
  //meklejot <ltId, obj1,obj2> skatamies gan <ltId, obj1,obj2>
  //gan <inverseLInk(ltId),obj2, obj1>>

  //assert(invLinkTypeID);
  //liekam tabula 3
  //bool added=
  //  Links::instance().addNewLink(linkTypeId,objId1,objId2)
    // && Links::instance().addNewLink(invLinkTypeId,objId2,objId1)
  //  ;
  //assert(added);


  //liekam tabula 3
  //Links::instance().addNewLink(linkTypeId,objId1,objId2);

  // liekam tabula 4
  bool existsRec=
    LinkedPartnersIDListS::instance().existsRecord(linkTypeId,objId1);
  if ( existsRec ) {
    LinkedPartnersIDListS::instance().addPartner(linkTypeId,objId1,objId2);
  }else{
    //neko nedaram
  }

  long invLinkTypeID= RepositoryUser::getAssociationInverse(linkTypeId);
  assert(invLinkTypeID);
  bool existsInvRec=
    LinkedPartnersIDListS::instance().existsRecord(invLinkTypeID,objId2);
  if ( existsInvRec ){
    LinkedPartnersIDListS::instance().addPartner(invLinkTypeID,objId2,objId1);
  }else{
    //neko nedaram
  }

  //return added;
  return true;
}//
*/

//bool RepositoryUser::createLink_2(long linkTypeId, long objId1 , long objId2){
//
//  int created=CreateLink(linkTypeId,objId1,objId2);
//
//  if ( created ){
//    RepositoryChangeListener::instance().linkCreated( linkTypeId ,
//                                                        objId1 , objId2 );
//  }
//
  //long invLinkTypeID= GetInverseLinkTypeId(linkTypeId);
  //meklejot <ltId, obj1,obj2> skatamies gan <ltId, obj1,obj2>
  //gan <inverseLInk(ltId),obj2, obj1>>

  //assert(invLinkTypeID);
  //liekam tabula 3
  //bool added=
  //  Links::instance().addNewLink(linkTypeId,objId1,objId2)
    // && Links::instance().addNewLink(invLinkTypeId,objId2,objId1)
  //  ;
  //assert(added);

  //Links::instance().addNewLink(linkTypeId,objId1,objId2);
  // liekam tabula 4
//  bool existsRec=
//    LinkedPartnersIDListS::instance().existsRecord(linkTypeId,objId1);
//  if ( existsRec ) {
//    LinkedPartnersIDListS::instance().addPartner(linkTypeId,objId1,objId2);
//  }else{
//    //neko nedaram
//  }

//  long invLinkTypeID= GetInverseLinkTypeId(linkTypeId);
//  //assert(invLinkTypeID);
//  bool existsInvRec=
//    LinkedPartnersIDListS::instance().existsRecord(invLinkTypeID,objId2);
//  if ( existsInvRec ){
//    LinkedPartnersIDListS::instance().addPartner(invLinkTypeID,objId2,objId1);
//  }else{
//    //neko nedaram
//  }
//
//  return true;
//}//

bool RepositoryUser::deleteLink_2(long linkTypeId, long objId1 , long objId2){
  int deleted=DeleteLink(linkTypeId,objId1,objId2);

  if ( deleted ){
    RepositoryChangeListener::instance().linkDeleted( linkTypeId ,
                                                        objId1 , objId2 );
  }

  //bool deleted_loc =
  //  Links::instance().deleteLink(linkTypeId,objId1,objId2);
  return deleted; //&& deleted_loc

}//


bool RepositoryUser::deleteLink(long linkTypeId, long objId1 , long objId2){
  bool pre  = linkTypeId != 0 && objId1 != 0 && objId2 !=0 ;
  assert(pre);

  int deleted=DeleteLink(linkTypeId,objId1,objId2);
  assert(deleted);

  if ( deleted ){
    RepositoryChangeListener::instance().linkDeleted( linkTypeId ,
                                                        objId1 , objId2 );
  }

  //bool deleted_loc =
  //  Links::instance().deleteLink(linkTypeId,objId1,objId2);
  //assert(deleted_loc);
  return deleted;
}//

bool RepositoryUser::setAttributeValue(long objectID,
                                       long attributeID,const string & newValue){
  //int result=AddProperty( objectID , attributeID, newValue.c_str() );
  //assert(result);  return result;
  return RepositoryUser::setAttributeValue ( objectID ,
                                             attributeID, (WideString) newValue.c_str() );
}//


//void debugPrint(long objectID,long attributeID,const WideString & v){
//  assert( CheckPropertyValue(attributeID,v) );
  //ostringstream s;
//  cout<<"objectID "<< objectID <<(ObjectExists(objectID)?" object exists ":" object does not exist")<<endl;

//  cout<< "attributeID " <<attributeID<< " value " <<WideCharToString(v).c_str()<<endl;
//  ShowMessage(v);
  //cout << WideCharToString(v).c_str()<<endl;
  //cout<<string(AnsiString(v.IsEmpty() ? L"" : v.c_bstr() ).c_str())<<endl;

//}


bool RepositoryUser::setAttributeValue(long objectID,long attributeID,const WideString & value){
  assert( CheckPropertyValue(attributeID,value) );
  //debugPrint(objectID,attributeID,value);
  int result=AddProperty( objectID , attributeID, value );
  if( result ){
    RepositoryChangeListener::instance().attributeValueSet( objectID ,
                                                            attributeID ,
                                                            value
                                                           );
  }
  assert(result);
  return result;
}//

string RepositoryUser::getAttributeValue(long objectID,long attributeID){
  WideString ws=GetPropertyValue( objectID , attributeID );
  AnsiString ansi(ws);
  return (string)(ansi.c_str());
}//

WideString RepositoryUser::getAttributeValue_2(long objectID,long attributeID){
  return GetPropertyValue( objectID , attributeID );
}//


long RepositoryUser::getLinkedObjectNum(long objTypeId , long linkTypeId){
   return GetLinkedObjectNum(objTypeId,linkTypeId);
}//

long RepositoryUser::getLinkedObjectIdByIndex(long objId , long linkTypeId, int index ){
   return GetLinkedObjectIdByIndex(objId,linkTypeId,index);
}//

bool RepositoryUser::hasSubClasses(const string & className){
  return RepositoryUser::hasSubClasses( GetObjectTypeIdByName(className.c_str()));
}//

bool RepositoryUser::hasSubClasses(long classID){
  assert(classID);
  if ( classID == 0 ) return false;
  TList * baseExtensions = GetExtensionIdList(classID);
    bool hasSubs=0;
    //if (baseExtensions)  hasSubs = baseExtensions->Count >= 0 ;
    if (baseExtensions)  hasSubs = baseExtensions->Count > 0 ;
  delete baseExtensions; baseExtensions=0;
  return hasSubs;
}//


bool RepositoryUser::isElementaryBaseType(char baseType){
  bool b = baseType == BaseType_STRING || baseType == BaseType_INTEGER ||
           baseType == BaseType_FLOAT  || baseType == BaseType_BOOLEAN ;
  return b;
}//

bool RepositoryUser::equalsBaseTypeMyBaseTypeEBM(baseType b, char c){
  bool match = b == Str  && c == BaseType_STRING  ||
               b == MyInt  && c == BaseType_INTEGER ||
               b == Real && c == BaseType_FLOAT   ||
               b == Bool && c == BaseType_BOOLEAN;
  return match;
}//

bool RepositoryUser::isCardinality(char card){
  bool b = card == Card_01 || card == Card_0N ||
           card == Card_1  || card == Card_1N;
  return b;
}//

string RepositoryUser::getTypeName( long typeID ){
  AnsiString res=GetTypeName( typeID );
  return res.c_str();
}//

string RepositoryUser::getClassName( long classID ){
  return getTypeName( classID );
}//

long RepositoryUser::getObjectTypeId( long objId ){
   return GetObjectTypeId( objId );
}//

long RepositoryUser::getPackageIdByName(const string & pckName){
  return GetPackageIdByName(pckName.c_str());
}

long RepositoryUser::createPackage(const string & pckName){
  long newPck = CreatePackage(pckName.c_str() , "" , 0 );
  return newPck;
}//

int RepositoryUser::setPackage( long pckId , long lastPckId ){
  int res = ::SetPackage(pckId,lastPckId);
  return res;
}//






long RepositoryUser::createClass(const string & className){
  long clID = getClassIdByName( className );
  bool alreadyExists = clID != badObjectTypeID;
  if( alreadyExists ) return clID;

  long newClID = CreateObjectType1( 0 , className.c_str() , "" , "" , "" ,0,"", 0 , 0);
  if( ! newClID ){
    AnsiString msg = "Class \"";
    msg+=  className.c_str();      msg+=  "\" was not created.";
    ShowMessage( msg );
    assert(!"Object type creation failed.");
  }else{
    //L0_ObjectIDListS::instance().addClassID( newClID );
  }
  return newClID;
}//

void RepositoryUser::deleteClass(long classID){
  //bool exists = ! GetTypeName( classID ).IsEmpty();
  //if( ! exists ) return false;
  //return
  DeleteObjectType( classID );
}//

long RepositoryUser::createAttr( const string & attrName , char baseType){
  assert( baseType == BaseType_STRING || baseType == BaseType_INTEGER ||
          baseType == BaseType_FLOAT || baseType == BaseType_BOOLEAN  ||
          baseType == BaseType_ENUMERATION
        );
  long propTypeID = RepositoryUser::getAttributeIdByName( 0 , attrName.c_str() );
  if( propTypeID ) return propTypeID;

  long newID = CreatePropertyType( attrName.c_str() , "" , baseType, 1 , "" , "" );
  assert( newID );
  return newID;
}//

long RepositoryUser::createEnum( const string & attrName ){
  return createAttr(attrName, BaseType_ENUMERATION );
}//


bool RepositoryUser::deleteAttr( long attrID ){
  bool exists = ! GetTypeName( attrID ).IsEmpty() ;
  if( ! exists ) return false;
  return DeletePropertyType( attrID );
}//

bool RepositoryUser::addAttr( long attrID , long classID){
  int added = AddPropertyType( classID , attrID );
  return added;
}//

bool RepositoryUser::removeAttr( long attrID , long classID){
  int added = RemovePropertyType( classID , attrID );
  return added;
}//

void RepositoryUser::addEnumLiteralToEnum(long enumID , const string & enumLiteral){
  string enumName (AnsiString(GetTypeName(enumID)).c_str());
  string s = "Addition of element \"" +enumLiteral+"\" to enumeration \"" +
             enumName + "\" failed.";
  #ifndef BUILDING_TRANSLATOR_FOR_EBM
    int ok=SetEnum( enumID , enumLiteral.c_str() );//returns -1 on error
    //assert( ok );
    if( ok == -1  ){
      ShowMessage( s.c_str() );
    }
  #else
    ShowMessage( "addEnumLiteralToEnum is not implemented in ect_data.dll.\n" + AnsiString(s.c_str()) );
  #endif
}//

void RepositoryUser::removeEnumLiteral(long /*enumID*/ , const string & /*enumLiteral*/){

   /* TODO : 
	 Implement function  RepoUser::removeEnumLiteral
     postponed because repo has no corresponding funct */

   assert( ! "Not implemented." );

}//

bool RepositoryUser::enumHasElem(const string & enumName , const string enumElemName){
  long enumId = GetPropertyTypeIdByName( 0 , enumName.c_str() );
  if( enumId == 0 ) return false;

  //__EXPORT_TYPE1 int GetEnumValueByName(long PropertyTypeId, WideString Name); // returns -1 on error

  bool has = GetEnumValueByName(enumId, enumElemName.c_str()) != -1 ;
  return has;
}


long RepositoryUser::createAssociation( const string & subjectRoleName,
                                        const string & objectRoleName,
                                        long subjClID,char subjEndCard,
                                        long objClID, char objEndCard,
                                        bool fromIsOrdered, bool toIsOrdered)
{
  int linkTypeId = 0;
  #ifndef BUILDING_TRANSLATOR_FOR_EBM
    linkTypeId =  CreateLinkType( subjectRoleName.c_str() , "" , objectRoleName.c_str() ,
                        subjClID, subjEndCard , Role_IndependentPartner,(fromIsOrdered ? 1 : 0),
                        objClID, objEndCard, Role_IndependentPartner,(toIsOrdered ? 1 : 0)
                        );
  #else
    linkTypeId = CreateLinkType1( subjectRoleName.c_str() , "" , objectRoleName.c_str() ,
                        subjClID, subjEndCard , Role_IndependentPartner,
                        objClID, objEndCard, Role_IndependentPartner,
                        "","","",0);
    if( fromIsOrdered || toIsOrdered )
      ShowMessage("Ordered associations are not supported in EBM.");
  #endif
  return linkTypeId;
}//

long RepositoryUser::createComposition( const string & subjectRoleName,
                                        const string & objectRoleName,
                                        long subjClID,char subjEndCard,
                                        long objClID, char objEndCard,
                                        bool fromIsOrdered, bool toIsOrdered )
{
  //int linkTypeId = CreateLinkType1( subjectRoleName.c_str() , "" , objectRoleName.c_str() ,
  //                      subjClID, subjEndCard , Role_Aggregate,
  //                      objClID, objEndCard, Role_Part,
  //                      "","","",0);
  int linkTypeId = 0;
  #ifndef BUILDING_TRANSLATOR_FOR_EBM
    linkTypeId = CreateLinkType( subjectRoleName.c_str() , "" , objectRoleName.c_str() ,
                        subjClID, subjEndCard , Role_Aggregate, (fromIsOrdered ? 1 : 0),
                        objClID, objEndCard, Role_Part, (toIsOrdered ? 1 : 0)
                        );
  #else
    linkTypeId = CreateLinkType1( subjectRoleName.c_str() , "" , objectRoleName.c_str() ,
                        subjClID, subjEndCard , Role_Aggregate,
                        objClID, objEndCard, Role_Part,
                        "","","",0);
    if( fromIsOrdered || toIsOrdered )
      ShowMessage("Ordered associations are not supported in EBM.");
  #endif

  return linkTypeId;
}//

void RepositoryUser::deleteAssociation(long assocID){
  DeleteLinkType( assocID );
}//

int RepositoryUser::createGeneralization(long baseClassID , long derivedClassID ){
  string derivedName = getTypeName( derivedClassID );
  string pureName; vector<string> v;
  StrRoutine::splitQName(derivedName ,v, pureName);
  int updatedOk = UpdateObjectType( baseClassID , derivedClassID , pureName.c_str() , "" , "" , "");
  return updatedOk;

}//

int RepositoryUser::deleteGeneralization(long /*baseClassID*/ , long  derivedClassID){
  string derivedName = getTypeName( derivedClassID );
  string pureName; vector<string> v;
  StrRoutine::splitQName(derivedName ,v, pureName);
  int updatedOk = UpdateObjectType( 0 , derivedClassID , pureName.c_str() , "" , "" , "");
  return updatedOk;
}//

