///*
//---------------------------------------------------------------------------

#ifndef strRoutineH
#define strRoutineH
//---------------------------------------------------------------------------
//#include <string.h>
//#include "sr_string.h"/
//#include "sr_vector.h"

#include <string>
#include <vector>

using std::string;
using std::vector;

class StrRoutine{
  private:

  public:
  //apgriez tuksumus no sakuma un no beigam
  //static void trim(string * str);
  static void trim(string & str);
  static bool split( const string & in_str , const string & delimiter,
                     string & beforeDelimiter , string & afterDelimiter);
  static bool split( const string & in_str , char delimiter ,
                     string & beforeDelimiter , string & afterDelimiter);
  static bool splitWithWSpaces( const string & in_str ,
                     string & beforeDelimiter , string & afterDelimiter);
  static bool splitDottedTriple( const string & in_str ,
                                 string & firstPart , string & secondPart ,
                                 string & thirdPart);
  //mekle ieejas stringa fragmentu fragment.
  //Pie tam gan pirms gan pec obligati ir vismaz viens whiteSpace
  static string::size_type findSpacedFragment(const string & in_str,
                           const string & fragment, string::size_type startInd);
  //no labas uz kreiso
  static string::size_type RfindSpacedFragment(const string & in_str,
                           const string & fragment, string::size_type startInd);

  static bool extractElsePart(const string & inStr,string & inStrWithoutElsePart,
                     string & elseLabelName );
  static bool extractGotoPart(const string & inStr,string & inStrWithoutGotoPart,
                     string & elseLabelName );

  static bool getFirstRelOpIndexAndSize(const string & in_str,
                                        string::size_type & index,int & size);
  static bool removeEnclosingSemicolon(string & str);
  static bool isCorrectIndex(const string & str, string::size_type ind);
  //parbauda vai strings str satur whitespaces tajos indeksos , kuri tiek padoti masiva
  //indCount masiva elementu Skaits
  static bool hasSpaceAt(const string & str , int * indexes ,int indCount);
  static bool hasSpaceAt(const string & str , string::size_type  ind);

  //  Ja str ir tukss atgriez npos
  //  Ja space nav atrasts atgriez npos
  //  Ja start_ind ir nekorekts atgirez npos
  //  Meklesanu sak uzreiz no start_ind
  //  Piem : getSpaceINd ("ad d",2) atgriez 2
  //  Rget reverseget  mekle no labas puses uz kreiso
  static string::size_type getNonSpaceInd( const string & str , string::size_type start_ind);
  //static string::size_type RgetNonSpaceInd( const string & str , string::size_type start_ind);

  static string::size_type getSpaceInd( const string & str , string::size_type start_ind);
  //static string::size_type RgetSpaceInd( const string & str , string::size_type start_ind);

  //static bool lineStartsWith (string * line , const string * prefix);
  static bool lineStartsWith (const string & line , const string & prefix);

  // atgrie true ja line ir sekojosa forma line=="prefix"+space+kautkas
  //piem  lineStartsWithAndSpace("absd sdfse ss   io1,220","absd")==true
  //static bool lineStartsWithAndSpace(string * line, const string * prefix);
  static bool lineStartsWithAndSpace(const string & line, const string & prefix);

  static bool isRelationalOperator(const string & in_str);
  static string replaceSpecSymbs(const string & str);

  static void splitQName( const string & inQName ,
                          vector<string> & qualifiers, string & pureName);
  static string replaceEscapeSequences(const string & in);                          
};


#endif

//*/
