#include "userDefinedNativeFunctions.h"
#include "mii_rep_api.h"
#include <stdio.h>
#include <algorithm>


void L0_Func_ext_showMsg(string  &s){
  ShowMessage(s.c_str());
}

static bool IsEmptySetEmptyPre(const L0_Var_2 & obj,  const string & attrName, long & attrID_prm){
  if( obj.isNull() ) return false;

  long classID = GetObjectTypeId( obj.getCurrentObjID() );
  long attrID = GetPropertyTypeIdByName(classID,attrName.c_str());

  if( ! attrID ) return false;

  char attrType=0;
  int res=0;
  {
    char tempPrm1=0; WideString tempPrm2, tempPrm3;
    res = GetPropertyTypeAttributes(attrID, attrType, tempPrm1,tempPrm2,tempPrm3); // 0 - error
  }

  if( ! res ) return false;

  bool hasSuitableType = attrType == BaseType_INTEGER || attrType == BaseType_FLOAT ||
                         attrType == BaseType_BOOLEAN || attrType == BaseType_ENUMERATION;
  if( hasSuitableType ){
    attrID_prm = attrID;
  }
  return hasSuitableType;
}

bool L0_Func_IsAttrValEmpty( L0_Var_2 & obj , string & attrName){
  long attrID=0;
  if( ! IsEmptySetEmptyPre(obj,attrName,attrID) ) return true;
  WideString attrVal = GetPropertyValue( obj.getCurrentObjID() , attrID );
  bool isEmpty = attrVal.IsEmpty() || (attrVal == WideString(L""));
  return isEmpty;
}

bool L0_Func_NotAttrValEmpty( L0_Var_2 & obj , string & attrName){
  return !L0_Func_IsAttrValEmpty(obj,attrName);
}

void L0_Func_SetAttrValEmpty( L0_Var_2 & obj , string & attrName){
  long attrID=0;
  if( ! IsEmptySetEmptyPre(obj,attrName,attrID) ) return;
  AddProperty( obj.getCurrentObjID() , attrID, WideString(L"") );
}

string L0_Func_toUpper ( string L0_func_param_s) {
        return strupr((char *) L0_func_param_s.c_str());
}

string L0_Func_toLower ( string L0_func_param_s) {
        return strlwr((char *) L0_func_param_s.c_str());
}

long L0_Func_indexOf ( string L0_func_param_ss , string L0_func_param_s)
{
        return L0_func_param_s.find(L0_func_param_ss,0)==L0_func_param_s.npos ? 0 : L0_func_param_s.find(L0_func_param_ss,0)+1;
}

void L0_Func_writeToFile ( string L0_func_param_towrite , string L0_func_param_fileName)
{
   FILE *stream;
   stream = fopen(L0_func_param_fileName.c_str(), "w");
   fprintf(stream, L0_func_param_towrite.c_str());
   fclose(stream);
}

string L0_Func_getAssocCardinality(string class_name, string rolename)
{
        long i1,i2,i3;
        char c1,c2;
        long class_id = GetObjectTypeIdByName(class_name.c_str());
        long assoc_id = GetLinkTypeIdByName(class_id, rolename.c_str());
        int i = GetLinkTypeAttributes1(assoc_id,i1,c1,i2,c2,i3);
        if (c1==Card_01) {return "0..1";};
        if (c1==Card_0N) {return "*";};
        if (c1==Card_1) {return "1";};
        if (c1==Card_1N) {return "1..*";};
        return "";
}

long L0_Func_Pos ( string L0_func_param_s , string L0_func_param_ss, long L0_func_param_i)
{
        return L0_func_param_s.find(L0_func_param_ss,L0_func_param_i)==L0_func_param_s.npos ? -1 : L0_func_param_s.find(L0_func_param_ss,L0_func_param_i);
}

string L0_Func_Trim ( string L0_func_param_s)
{
        string::size_type pos1 = L0_func_param_s.find_first_not_of(' ');
        string::size_type pos2 = L0_func_param_s.find_last_not_of(' ');
        return L0_func_param_s.substr(pos1 == string::npos ? 0 : pos1,pos2 == string::npos ? L0_func_param_s.length() - 1 : pos2 - pos1 + 1);
}

void L0_Func_STOP ( )
{
        throw L0_Var_2_Exception("");
}
 //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 ////!!!!!!No s vietas pielikts !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

string getDllPath(string s1) {
// s1 - dll name
//     char buffer[MAXPATH];
//     HMODULE h = GetModuleHandle(s1.c_str());
//     if (!h) return "";
//     if (!GetModuleFileName(h, buffer, MAXPATH)) return "";
//     string retPath(buffer);
//     string::size_type pos = retPath.rfind("\\" + s1); //pos1 == string::npos if not found
//     return retPath.substr(0, pos);
}

void L0_Func_ext_callExternalExecutable (string  &s1, string  &s2, string  &s3) {
// s1 - executable name, s2 - parameters, s3 - reserved for future...

  HINSTANCE extExecutable;
  extExecutable = ShellExecute(NULL, "open", s1.c_str(), s2.c_str(), NULL, SW_SHOW);
  if ( (int)extExecutable <= 32)
    MessageBox(NULL,
         ("Execution of " + s1 + " failed").c_str(),
         "External call",
         MB_OK|MB_ICONERROR);
}

//maps the specified executable module into the address space of the calling process
void L0_Func_ext_callExternalDll (string  &s1, string  &s2, string  &s3) {

  HINSTANCE extDllInstance;
  typedef void (*type_CustomOpen0)();
  typedef void (*type_CustomOpen1)(std::string);
  type_CustomOpen0 func_CustomOpen0;
  type_CustomOpen1 func_CustomOpen1;
  extDllInstance = LoadLibrary(s1.c_str());
  if (!extDllInstance) {
     MessageBox(NULL,
          (s1 + " library not found").c_str(),
          "External DLL call",
          MB_OK|MB_ICONERROR);
  }
  else {
      if (s3.empty())
      {
       func_CustomOpen0 = (type_CustomOpen0) GetProcAddress(extDllInstance,('_'+s2).c_str());
       if (!func_CustomOpen0){
         MessageBox(NULL,
            (s2 + " function not found").c_str(),
            "External DLL call",
            MB_OK|MB_ICONERROR);
       }
       else
       {
         func_CustomOpen0();
       }
      }
      else
      {
        func_CustomOpen1 = (type_CustomOpen1) GetProcAddress(extDllInstance,('_'+s2).c_str());
        if (!func_CustomOpen1){
         MessageBox(NULL,
            (s2 + " function not found").c_str(),
            "External DLL call",
            MB_OK|MB_ICONERROR);
        }
        else
        {
         func_CustomOpen1(s3);
        }
      }
  }

  if (extDllInstance)
    FreeLibrary(extDllInstance);

}

void L0_Func_ext_MOLACompiler ()
{
        endSession();
        L0_Func_ext_callExternalDll(string("MOLA2compiler.dll"),string("L0_LibMain"),string(""));
         startSession();
}

void L0_Func_ext_importXML (string  &s)
{
         L0_Func_ext_callExternalDll(string("XMLImpExp.dll"),string("MOLAImportXML"), s);
}

void L0_Func_ext_exportXML (string  &s)
{
        L0_Func_ext_callExternalDll(string("XMLImpExp.dll"),string("MOLAExportXML"), s);
}

void L0_Func_ext_CreateProjectFolders (string  &s1, string  &s2)
{  //s1 - project attribute Path value, s2 - model name
     string::size_type pos = s1.rfind(".repository"); //pos1 == string::npos if not found
     string wspMolaPath = s1.substr(0, pos) + ".mola/" + s2;
     //getcwd(buffer, MAXPATH); //get current working directory (it is supposed to be a METAclipse home)
     string molaResPath = getDllPath("L0_CompRes_wgb_mii.dll");
     pos = molaResPath.rfind("\\jre\\bin"); //pos1 == string::npos if not found
     molaResPath = molaResPath.substr(0, pos) + "\\plugins\\lv.lu.mii.metaclipse.mola.res";
     string tmpSysComm = "xcopy /E /Y /I \"" + molaResPath + "\" \"" + wspMolaPath + "\"";
     system(tmpSysComm.c_str());
}

void L0_Func_ext_L0Compiler (string  &s1, string  &s2, string  &s3)
{ //s1 - project attribute Path value, s2 - model name  , s3 - main unit name
     string::size_type pos1 = s1.rfind(".repository"); //pos1 == string::npos if not found
     string molaCompPath = s1.substr(0, pos1) + ".mola/" + s2;
     string paramStr = "L0_CompRes_wgb_mii false \"" + molaCompPath + "/l0/" + s3 + ".txt\" ";
     paramStr += "\"" + molaCompPath + "/compres/comp_result_MII\" \"" + molaCompPath + "\" false";
     std::replace( paramStr.begin(), paramStr.end(), '/', '\\');
     string dllPath = getDllPath("L0_CompRes_wgb_mii.dll");
     L0_Func_ext_callExternalExecutable(string(dllPath + "\\compileL0.exe"), paramStr, string(""));
}

void L0_Func_ext_L3L0Compiler ()
{
       endSession();
       L0_Func_ext_callExternalDll(string("L0_CompRes_wgb_mii_L3L0drukaa.dll"),string("L0_LibMain"), string(""));
       startSession();
}


